/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import java.util.*;


public class CondConfigRabiee extends FlowConfig 
{
    public CondConfigRabiee (){
    }

    public CondConfigRabiee (TechnoExch te){
        super(te);
        NuCorrel="Rabiee & al.";
		te.JPanel1.add(te.display_value);
		te.JPanel1.add(te.displayLabel);
		te.displayLabel.setText("pressure factor");
		te.display_value.setText("1");
    }
        
    public String getCode(){
        return "horiz cond";
    }

	public String getClassDescription(){
	    return "Rabiee & al. correlation for condensation inside horizontal tubes";
	}
    
	public double calcNu(double P){
//	    double Nu;
//	    double P=comp.amont.getP();
	    if(te.diph){//calcul de Ulv
	 //   	System.out.println(" te.corps "+te.corps.name+" te.corps PC "+te.corps.PC);
	    	double fact=P/te.corps.PC;
	        Nu=calcNu(te.aval.X,te.amont.X,fact);//nombre de Nsselt
	//    	System.out.println("condConfig Nu diph "+Nu);
	//    	System.out.println("condConfig Nu diph 2 "+Nu+" fact "+fact);
	    
	        //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	        double Tsat=te.corps.lecorps.getSatTemperature(P,0);
	        P=te.corps.lecorps.getSatPressure(Tsat, 0);
	        te.corps.lecorps.CalcPropCorps(Tsat, P, 0);
	        te.corps.getSubstProperties();
	        double Vl=te.corps.V;
	        Tsat=te.corps.lecorps.getSatTemperature(P,1);
	        P=te.corps.lecorps.getSatPressure(Tsat, 1);
	        te.corps.lecorps.CalcPropCorps(Tsat, P, 1);
	        te.corps.getSubstProperties();
	        double Vv=te.corps.V;
	        
	        calcMeanDensity(Vl, Vv, 1, 0);
	    
	    }
	    else {
	    	Nu=calcNuTube();
//	    	System.out.println("condConfig Nu "+Nu);
	    }
	    
	    return Nu;
	}
	
	
    private double calcNu(double xs, double xe, double fact){//nombre de Nsselt pour un tube
        //xs est le titre de sortie
        //xe est le titre d'entre
        //fact est un paramtre (Vv/Vl pour l'vaporation, PC/Pcond pour la condensation)
        
        
        double x=xs;//corrlation de Shah
        double F1= 0.5555556*Math.pow(1-x,1.8);///(1-x);
        double F2= 3.8*(0.2532 -(- 0.0155*x*x*x + 0.1669*x*x + 0.1083*x-0.0065));///(1-x);
		double Tsat=te.corps.lecorps.getSatTemperature(te.aval.P,0);
	    te.initLambdaMu(Tsat-0.05, te.aval.P, 0);
	    double F0=(F1+F2/Math.pow(fact, 0.38));
//        System.out.println("condConfig "+te.corps.name + " T : "+te.aval.T+ " x : "+xs+" mu : "+te.mu+" lambda : "+te.lambda);
//        System.out.println("condConfig "+te.corps.name + " F1 : "+F1+ " F2 : "+F2); 
       
	    if(false){//si prise en compte laminaire
            double Nu=0;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
	        double Re=te.getRe();
	        if(Re<=laminarLimit)Nu=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else if(Re>=turbulentLimit)Nu=Nut;
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            Nu=Nul+(Nut-Nul)*alpha;
	        }
            return Nu*(F1+F2*Math.pow(fact, 0.38));
	    }
	    else {
		    te.initLambdaMu(Tsat-0.05, te.aval.P, 0);
		    te.calcRe();
	        //prise en compte du taux de vide pour le calcul de la charge en frigorigne
//			double Tsat=te.corps.lecorps.getSatTemperature(te.aval.P,0);
	        double P=te.corps.lecorps.getSatPressure(Tsat, 0);
	        te.corps.lecorps.CalcPropCorps(Tsat, P, 0);
	        te.corps.getSubstProperties();
	        double Vl=te.corps.V;
	        Tsat=te.corps.lecorps.getSatTemperature(P,1);
	        P=te.corps.lecorps.getSatPressure(Tsat, 1);
	        te.corps.lecorps.CalcPropCorps(Tsat, P, 1);
	        te.corps.getSubstProperties();
	        double Vv=te.corps.V;

			
			//corrlation de Rabiee & al. (Sherbrooke)
			double Co=0;
			double m= -0.01993+0.0008306*te.G+0.0005007* Tsat;
			double n=-0.667;
			double y=0;
/*			for(int i=0;i<100;i++){
				x=i/100.;					    
				y= (1-x);
				Co=Co+y/100.;		    
			}
		    System.out.println("Co "+Co+" y "+y);// + " te.G : "+te.G + " m : "+m);
			double Co_0=m*Co*Math.pow(te.Re,n);*/
			Co=m*Math.pow(te.Re,n);
			double ro_l=1/Vl;
			double ro_v=1/Vv;
			y=Math.pow(te.lambda,3)*ro_l*(ro_l-ro_v)*9.81/te.mu/te.mu;
			double h_tot=1000*Co*Math.pow(y,1./3.);
			
//			double hc=techc.lambda*techc.Nu*fin_c/Util.lit_d(techc.Dh_value.getText());
			
			double fin=Util.lit_d(te.FA_value.getText())*Util.lit_d(te.etaF_value.getText());			
			double Nu=h_tot/te.lambda/fin*Util.lit_d(te.Dh_value.getText());
			
		    
	
		    System.out.println("Co "+Co + " te.G : "+te.G + " m : "+m+" Nu_sher "+Nu);

		    return Nu;
	    }
  //      else return 0.023*Math.pow(te.getRe(), 0.8)*Math.pow(te.getPr(), 0.4)*(F1+F2*Math.pow(fact, 0.38));
 //       return calcNuTube()*(F1+F2*Math.pow(fact, 0.38));
    }
	
	public double calcDP(){
	    te.initLambdaMu(te.amont.T, te.amont.P, 1);
	    return calcDPdiff();
	}
	
	public double calcDPdiff_(){
        double Tsat=te.corps.lecorps.getSatTemperature(te.aval.P, 0);//pression de condensation
	    te.corps.lecorps.CalcPropCorps(Tsat-0.1,te.aval.P,0);
	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
	    double dPl=calcDP(v);
	    double z=(1+Math.abs(te.aval.X-te.amont.X)*(te.ro_l/te.ro_g-1));
	    double y=(1+Math.abs(te.aval.X-te.amont.X)*(te.mu_l/te.mu_g-1));
	    y=Math.pow(y, -0.2);
 //       System.out.println(te.exchangeName+"  z "+z+"  te.ro_l "+te.ro_l+"  te.ro_g "+te.ro_g);	        
 //       System.out.println(te.exchangeName+"  y "+y+"  te.mu_l "+te.mu_l+"  te.mu_v "+te.mu_v);	        

	    double dPlv=z*y*dPl;
	    double dPv=calcDP(te.amont.V);
   //     System.out.println("dPl "+dPl+"  dPv "+dPv+"  dPlv "+dPlv);	        	    
	    dPl=calcDP(te.aval.V);
   //     System.out.println("dPl "+dPl+"  dPv "+dPv+"  dPlv "+dPlv);	        

	    double zz=0;//deux cas selon qu'il s'agit d'un changeur ou d'un thermocoupleur
	    if(te.tHx!=null)zz=te.tHx.Al/te.tHx.A*dPl+te.tHx.Alv/te.tHx.A*dPlv+te.tHx.Av/te.tHx.A*dPv;
	    if(te.tTc!=null)zz=te.tTc.Al/te.tTc.A*dPl+te.tTc.Alv/te.tTc.A*dPlv+te.tTc.Av/te.tTc.A*dPv;
	    
	    return zz;
	}

	
	public double calcDPdiff__(){
		super.calcDPdiff();
        double Tsat=te.corps.lecorps.getSatTemperature(te.aval.P, 0);//pression de condensation
	    te.corps.lecorps.CalcPropCorps(Tsat-0.1,te.aval.P,0);
	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
	    double dPl=calcDP(v);
	    
	    
  	    te.corps.lecorps.CalcPropCorps(Tsat+0.1,te.aval.P,0);
 	    vProp=te.corps.lecorps.getSubstProperties();
        f=(Double)vProp.elementAt(3);
        v=f.doubleValue();
        double ro_g=1/v;
        te.ro_g=ro_g;
        double Re=te.getRe();
        f=(Double)vProp.elementAt(5);
        double hv=f.doubleValue();
        te.initLambdaMu(Tsat+0.1,te.aval.P, 1);
        double mu_v=te.mu;
        Tsat=te.corps.lecorps.getSatTemperature(te.aval.P, 0)-0.1;
 	    te.corps.lecorps.CalcPropCorps(Tsat-0.1,te.aval.P,0);
	    vProp=te.corps.lecorps.getSubstProperties();
        f=(Double)vProp.elementAt(3);
        v=f.doubleValue();
        double ro_l=Math.pow(v, -1);
  /*      te.corps.getSubstProperties();
        f=(Double)vProp.elementAt(5);
        double hl=f.doubleValue();
	    te.corps.lecorps.CalcPropCorps(T,P_calc,0);
	    vProp=te.corps.lecorps.getSubstProperties();
	    f=(Double)vProp.elementAt(5);
	    double Cpl=(f.doubleValue()-hl)*10;
            
        double Lv=(hv-hl)*1000.;//Latent heat in J/kg
        
        double Bo;//nombre d'bullition
        if(te.tHx.firstIteration)//On utilise cette formule simplifie avant tout calcul
        Bo=Util.lit_d(te.Dh_value.getText())/4./Util.lit_d(te.L_value.getText());
        else Bo=te.tHx.qlv/te.getFlow()*Util.lit_d(te.Ac_value.getText())/Lv;
       */
	    te.initLambdaMu(Tsat-0.1,te.aval.P, 0);
        double mu_l=te.mu;
	    
 //       System.out.println(te.exchangeName+"  z "+z+"  te.ro_l "+te.ro_l+"  te.ro_g "+te.ro_g);	        
 //       System.out.println(te.exchangeName+"  y "+y+"  te.mu_l "+te.mu_l+"  te.mu_v "+te.mu_v);	        
		double phi2=0;
		
	    //modle HEM de Herer & Gallori
		for(int i=0;i<100;i++){
			double x=i/100.;					    
		    double z=(1+x*(te.ro_l/te.ro_g-1));
		    double y=(1+x*(te.mu_l/te.mu_g-1));
		    y=Math.pow(y, -0.2);
		    //On multiplie z*y par le coefficient de frottement f_2phi_lo
			phi2=phi2+z*y*0.184*Math.pow(te.getRe()*(1-x), -0.2)/100.;		    
	//		System.out.println(te.exchangeName+"  y "+y+"  te.mu_l "+te.mu_l+"  te.mu_v "+te.mu_g);	        
	//		System.out.println(te.exchangeName+"  z "+z+"  te.ro_l "+te.ro_l+"  te.ro_g "+te.ro_g);	        

		}
		//On redivise par le coefficient de frottement par dfaut
		double F=phi2/getFrictionFactor();
		System.out.println("modle HEM de Herer & Gallori\t"+"\tF\t"+F);		
/*	    double z=(1+(te.ro_l/te.ro_g-1));
	    double y=(1+(te.mu_l/te.mu_g-1));
	    y=Math.pow(y, -0.2);
	    double F=z*y;
		System.out.println("modle HEM de Herer & Gallori\t"+"\tF\t"+F);		
*/
	    double dPlv=phi2*dPl;
//	    dPlv=phi2;
	    double dPv=calcDP(te.amont.V);
   //     System.out.println("dPl "+dPl+"  dPv "+dPv+"  dPlv "+dPlv);	        	    
	    dPl=calcDP(te.aval.V);
   //     System.out.println("dPl "+dPl+"  dPv "+dPv+"  dPlv "+dPlv);	        

	    double zz=0;//deux cas selon qu'il s'agit d'un changeur ou d'un thermocoupleur
	    if(te.tHx!=null)zz=te.tHx.Al/te.tHx.A*dPl+te.tHx.Alv/te.tHx.A*dPlv+te.tHx.Av/te.tHx.A*dPv;
	    if(te.tTc!=null)zz=te.tTc.Al/te.tTc.A*dPl+te.tTc.Alv/te.tTc.A*dPlv+te.tTc.Av/te.tTc.A*dPv;
	    
	    return zz;
	}

	
	

	public double getPressFactor(){
	    return Util.lit_d(te.display_value.getText());
    }
	public void setPressFactor(double fact){
	    te.display_value.setText(Util.aff_d(fact));
    }
	
	
	/**
	 * reads specific technoDesign parameters
	 */
	public void readCaract(String ligne_data){
	    super.readCaract(ligne_data);
        String valeur;
        valeur=Util.extr_value2(ligne_data, "pressure_factor");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.display_value.setText(valeur);
        }
	}

	/**
	 * saves specific technoDesign parameters
	 */
    public String saveCaract(){
	    String h=super.saveCaract();
        h=h+"pressure_factor="+te.display_value.getText()+":"
        ;
        return h;
    }
	
	

}