/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.Vector;


public class EvapConfig extends FlowConfig 
{
    public EvapConfig (){
    }

    public EvapConfig (TechnoExch te){
        super(te);
        NuCorrel="Gungor Winterton";
		te.JPanel1.add(te.display_value);
		te.JPanel1.add(te.displayLabel);
		te.displayLabel.setText("pressure factor");
		te.display_value.setText("1");
    }
        
    public String getCode(){
        return "evap";
    }
  
	public String getClassDescription(){
	    return "Gungor Winterton correlation for evaporation inside tubes and annuli";
	}
    
	public double calcNu(double P){
	    if(te.diph){//calcul de Ulv
	        double Tsat=te.corps.lecorps.getSatTemperature(P,0);
	        double Psat=te.corps.lecorps.getSatPressure(Tsat, 0);
	        te.corps.lecorps.CalcPropCorps(Tsat-0.1, Psat, 0);
	        te.corps.getSubstProperties();
	        double Vl=te.corps.V;
	        Tsat=te.corps.lecorps.getSatTemperature(P,1);
	        Psat=te.corps.lecorps.getSatPressure(Tsat, 1);
	        te.corps.lecorps.CalcPropCorps(Tsat+0.1, Psat, 1);
	        te.corps.getSubstProperties();
	        double Vv=te.corps.V;
	        double fact=Vv/Vl;
	   // 	System.out.println("Vv diph "+Vv+"  Vl "+Vl);
	        Nu=calcNu(te.aval.X,te.amont.X,fact);//nombre de Nsselt
	  //  	System.out.println("evapConfig Nu diph "+Nu);
	  //  	System.out.println("Re diph "+te.getRe()+"  Pr "+te.getPr());

	        //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	        calcMeanDensity(Vl, Vv, te.aval.X, te.amont.X);
	    }
	    else Nu=calcNuTube();
	    
	    return Nu;
	}
	
    private double calcNu_(double xs, double xe, double fact){//nombre de Nsselt pour un tube
        //xs est le titre de sortie
        //xe est le titre d'entre
        //fact est un paramtre (Vv/Vl pour l'vaporation, PC/Pcond pour la condensation)
        
        // corrlation de Gungor et Winterton
        double Bo;//nombre d'bullition
        Bo=Util.lit_d(te.Dh_value.getText())/4./Util.lit_d(te.L_value.getText());
        System.out.println("Bo EvapConfig : "+Bo);
        double Fs= -0.0079*xs*xs*xs*xs - 0.131*xs*xs*xs + 0.6128*xs*xs + 0.0651*xs - 0.0054;
        double Fe= -0.0079*xe*xe*xe*xe - 0.131*xe*xe*xe + 0.6128*xe*xe + 0.0651*xe - 0.0054;
        double F=1.12*(Fs-Fe)/(xs-xe);
        Fs=-1/1.8*Math.pow(1-xs,1.8);
        Fe=-1/1.8*Math.pow(1-xe,1.8);
        double F2=(Fs-Fe)/(xs-xe);
        
        double T=te.corps.lecorps.getSatTemperature(te.amont.P, 0)-0.1;
        te.corps.getSubstProperties();
   //     System.out.println("EvapConfig "+te.corps.name+ " T : "+T+ " P : "+te.amont.P+T+ " x : "+te.amont.X);
   // 	System.out.println("Re diph 1 "+te.getRe()+"  Pr "+te.getPr());

	    te.initLambdaMu(T,te.amont.P, 0);
        
	    if(false){//si prise en compte laminaire
            double Nu=0;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
	        double Re=te.getRe();
	        if(Re<=laminarLimit)Nu=Nul;
	        else if(Re>=turbulentLimit)Nu=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            Nu=Nul+(Nut-Nul)*alpha;
	        }
	        
            return Nu*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
        }
        else {
	        double Fact=(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
	 //       System.out.println("Fact "+Fact);
	        //attention : on multiplie Re par (1-x) car dans la corrlation de Gungor et Winterton 
	        //le calcul de Nuliq doit tre fait avec le dbit de la phase liquide seule 
	        
	        return C1*Math.pow(te.getRe()*(1.-te.amont.X),a_Re)*Math.pow(te.getPr(),b_Pr)*Fact;
        }

		    //       else return 0.023*Math.pow(te.getRe(), 0.8)*Math.pow(te.getPr(), 0.4)*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
 //      return calcNuTube()*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
    }
	
    private double calcNu(double xs, double xe, double fact){//nombre de Nsselt pour un tube
        //xs est le titre de sortie
        //xe est le titre d'entre
        //fact est un paramtre (Vv/Vl pour l'vaporation, PC/Pcond pour la condensation)
        
        // corrlation de Gungor et Winterton
        double Bo;//nombre d'bullition
        Bo=Util.lit_d(te.Dh_value.getText())/4./Util.lit_d(te.L_value.getText());
        System.out.println("Bo EvapConfig: "+Bo);
        double Fs= -0.0079*xs*xs*xs*xs - 0.131*xs*xs*xs + 0.6128*xs*xs + 0.0651*xs - 0.0054;
        double Fe= -0.0079*xe*xe*xe*xe - 0.131*xe*xe*xe + 0.6128*xe*xe + 0.0651*xe - 0.0054;
        double F=1.12*(Fs-Fe)/(xs-xe);
        Fs=-1/1.8*Math.pow(1-xs,1.8);
        Fe=-1/1.8*Math.pow(1-xe,1.8);
        double F2=(Fs-Fe)/(xs-xe);
        
        double Tsat=te.corps.lecorps.getSatTemperature(te.aval.P, 0);
        te.corps.getSubstProperties();
        te.corps.getSubstProperties();
 	    te.corps.lecorps.CalcPropCorps(Tsat+0.1,te.aval.P,0);
  	    Vector vProp=te.corps.lecorps.getSubstProperties();
         Double f=(Double)vProp.elementAt(3);
         double v=f.doubleValue();
         double ro_g=1/v;
         te.ro_g=ro_g;
         double Re=te.getRe();
         f=(Double)vProp.elementAt(5);
         double hv=f.doubleValue();
         te.initLambdaMu(Tsat+0.1,te.aval.P, 1);
         double mu_v=te.mu;
         Tsat=te.corps.lecorps.getSatTemperature(te.amont.P, 0);
  	     te.corps.lecorps.CalcPropCorps(Tsat-0.1,te.amont.P,0);
 	     vProp=te.corps.lecorps.getSubstProperties();
         f=(Double)vProp.elementAt(3);
         v=f.doubleValue();
         double ro_l=1/v;
         

	    te.initLambdaMu(Tsat-0.1,te.amont.P, 0);//modRG 2021
	    //j'ai remis  l'ancienne initialisation, je ne sais pas pourquoi j'avais modifi
	    //a change beaucoup les rsultats. A vrifier
	    //Toutefois, le nombre Bo n'est pas bien estim
//	    te.initLambdaMu(T-0.1,te.aval.P, 0);
        double mu_l=te.mu;

        
	    if(false){//si prise en compte laminaire
            double Nu=0;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
	        Re=te.getRe();
	        if(Re<=laminarLimit)Nu=Nul;
	        else if(Re>=turbulentLimit)Nu=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            Nu=Nul+(Nut-Nul)*alpha;
	        }
	        
            return Nu*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
        }
        else {
	        double Fact=(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
	    	double NUT =C1*Math.pow(te.getRe()*(1.-te.amont.X),a_Re)*Math.pow(te.getPr(),b_Pr)*Fact;    
	 //       System.out.println("Fact "+Fact);
	        //attention : on multiplie Re par (1-x) car dans la corrlation de Gungor et Winterton 
	        //le calcul de Nuliq doit tre fait avec le dbit de la phase liquide seule 

	        
			double x=xe;
			double NUT_GW=0;
        
//			System.out.println(te.exchangeName+"  xe "+xe+"  te.mu_l "+mu_l+"  te.mu_v "+mu_v);	        
//			System.out.println(te.exchangeName+"  xs "+xs+"  te.ro_l "+ro_l+"  te.ro_g "+ro_g);	        
			while(x<xs-1/100.){
				x=x+1/100.;	
				//NUT et h liquid only
				double Nut_lo=C1*Math.pow(te.getRe()*(1.-x),a_Re)*Math.pow(te.getPr(),b_Pr);
		        double h_lo=Nut_lo/Util.lit_d(te.Dh_value.getText())*te.lambda;
				
		        //Corrlation Gungor et Winterton
				Fact=1+3000*Math.pow(Bo,0.86)+1.12*Math.pow(x/(1-x),0.75)*Math.pow(ro_l/ro_g, 0.41);
//				NUT_GW=NUT_GW+Nut_lo*Fact/99.;
				NUT_GW=NUT_GW+Nut_lo*Fact/99./(xs-xe);
				
				
			}     
			System.out.println("GW moyen NUT\t"+NUT+"\tNUT_GW\t"+NUT_GW);
	        return NUT_GW;
        }

	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    //       else return 0.023*Math.pow(te.getRe(), 0.8)*Math.pow(te.getPr(), 0.4)*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
 //      return calcNuTube()*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
    }


	public double calcDP(){
	    return calcDPdiff();
	}

	public double getPressFactor(){
	    return Util.lit_d(te.display_value.getText());
    }

	public void setPressFactor(double fact){
	    te.display_value.setText(Util.aff_d(fact));
    }
	
	/**
	 * reads specific technoDesign parameters
	 */
	public void readCaract(String ligne_data){
	    super.readCaract(ligne_data);
        String valeur;
        valeur=Util.extr_value2(ligne_data, "pressure_factor");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.display_value.setText(valeur);
        }
	}

	/**
	 * saves specific technoDesign parameters
	 */
    public String saveCaract(){
	    String h=super.saveCaract();
        h=h+"pressure_factor="+te.display_value.getText()+":"
        ;
        return h;
    }
	

}