
/*
Copyright Renaud GICQUEL 2005-20010  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 * Classe pour calculer un cycle vapeur en rgime non-nominal
 * 
 * le modle de turbine est celui de Stodola
 *
 * enfin, bon nombre de noms de composants sont entrs dans le code alors qu'ils devraient tre automatiquement retrouvs
 *
 * il faut enfin faire du mnage car de nombreux bouts de code inutiliss proviennent de la classe Thrust
 *
 * Cette classe illustre la manire dont une classe externe peut piloter des reparamtrages 
 * varis d'un projet de structure donne
 *
 * @author Renaud GICQUEL
 */
public class EvaporatorExchangerDriver extends ExtPilot 
{
	boolean isInitialized=false;
	boolean isBuilt=false;
	String[]composant,nomComposant;
    String hxName, condName, echSettings="",compressorName="", condSettings="";
    
    TechnoEvaporator technoExchanger;
    TechnoCondensor technoCondenser;
    double Te,Tf,massFlow, DTsurch, DTssrefr, Aech, Uech, AechReel, AcondReel, U_ech, Preservoir;
    double tauTurb, DeltaHech, mCpmin, mCpmax, NUT,R,epsilon, AdesignEch, DeltaH;
    
    double UAech, UAcond, T2,Tech, Pech,Vech,Hech, mCpEau, mCpAir, lambdaVol, N_value, Vs;
        
    PointThopt hotUpstream, hotDownstream, coldUpstream, coldDownstream, amontCompr;
    PointThopt condUpstream, condDownstream, coldWaterInlet, coldWaterOutlet;
    
	String tab=new String("\t");
	String ligne=new String("\n");

	public EvaporatorExchangerDriver()
	{
		//{{INIT_CONTROLS
		setTitle("ORC cycle driver");
		getContentPane().setLayout(null);
		setSize(640,590);
		setVisible(false);
		bInitialSettings.setText("Initial settings");
		bInitialSettings.setActionCommand("load");
		getContentPane().add(bInitialSettings);
		bInitialSettings.setBounds(216,24,156,36);
		JLabel10.setText("Design settings");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(12,24,553,25);
		JLabel13.setText("given A Ech");
		getContentPane().add(JLabel13);
		JLabel13.setForeground(new java.awt.Color(102,102,153));
		JLabel13.setBounds(12,132,161,22);
		getContentPane().add(AdesignEch_value);
		AdesignEch_value.setBackground(java.awt.Color.white);
		AdesignEch_value.setBounds(180,132,100,24);
		JLabel15.setText("heat exchanger UA");
		getContentPane().add(JLabel15);
		JLabel15.setBounds(12,96,156,24);
		UAech_value.setSelectionColor(new java.awt.Color(204,204,255));
		UAech_value.setSelectedTextColor(java.awt.Color.black);
		UAech_value.setCaretColor(java.awt.Color.black);
		UAech_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(UAech_value);
		UAech_value.setBackground(java.awt.Color.white);
		UAech_value.setBounds(180,96,100,24);
		JLabel9.setText("calculated A Ech");
		getContentPane().add(JLabel9);
		JLabel9.setBounds(300,132,156,24);
		AcalculatedEch_value.setSelectionColor(new java.awt.Color(204,204,255));
		AcalculatedEch_value.setSelectedTextColor(java.awt.Color.black);
		AcalculatedEch_value.setCaretColor(java.awt.Color.black);
		AcalculatedEch_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		AcalculatedEch_value.setEditable(false);
		getContentPane().add(AcalculatedEch_value);
		AcalculatedEch_value.setBounds(468,132,100,24);
		JLabel1.setText("heat exchanger U");
		getContentPane().add(JLabel1);
		JLabel1.setForeground(new java.awt.Color(102,102,153));
		JLabel1.setBounds(300,96,190,22);
		U_value.setEditable(false);
		getContentPane().add(U_value);
		U_value.setBounds(468,96,100,24);

		JLabel14.setText("given A Cond");
		getContentPane().add(JLabel14);
		JLabel14.setForeground(new java.awt.Color(102,102,153));
		JLabel14.setBounds(12,232,161,22);
		getContentPane().add(AdesignCond_value);
		AdesignCond_value.setBackground(java.awt.Color.white);
		AdesignCond_value.setBounds(180,232,100,24);
		JLabel16.setText("Condenser UA");
		getContentPane().add(JLabel16);
		JLabel16.setBounds(12,196,156,24);
		UAcond_value.setSelectionColor(new java.awt.Color(204,204,255));
		UAcond_value.setSelectedTextColor(java.awt.Color.black);
		UAcond_value.setCaretColor(java.awt.Color.black);
		UAcond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(UAcond_value);
		UAcond_value.setBackground(java.awt.Color.white);
		UAcond_value.setBounds(180,196,100,24);
		JLabel8.setText("calculated A Cond");
		getContentPane().add(JLabel8);
		JLabel8.setBounds(300,232,156,24);
		AcalculatedCond_value.setSelectionColor(new java.awt.Color(204,204,255));
		AcalculatedCond_value.setSelectedTextColor(java.awt.Color.black);
		AcalculatedCond_value.setCaretColor(java.awt.Color.black);
		AcalculatedCond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		AcalculatedCond_value.setEditable(false);
		getContentPane().add(AcalculatedCond_value);
		AcalculatedCond_value.setBounds(468,232,100,24);
		JLabel2.setText("condenser U");
		getContentPane().add(JLabel2);
		JLabel2.setForeground(new java.awt.Color(102,102,153));
		JLabel2.setBounds(300,196,190,22);
		Ucond_value.setEditable(false);
		getContentPane().add(Ucond_value);
		Ucond_value.setBounds(468,196,100,24);		 
		
		getContentPane().add(JLabelFluid);
		JLabelFluid.setForeground(new java.awt.Color(102,102,153));
		JLabelFluid.setBounds(150,260,190,22);
		JLabelFluid.setText("");
		
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bInitialSettings.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="TechnoEvaporator driver";
	}

    /**
    * returns the component type 
    
    public String getCompType(){
        return type;
    }**/
    
	public String getClassDescription(){
	    return "driver for an evaporator\n\n\nauthor : R. Gicquel february 2013";
	}
    
    void setupProject(){
        //on rcupre ici les instances des transfos externes dont on a besoin
        //afin d'accder  leurs diffrents paramtres pour les calculs ultrieurs
        
  }
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == EvaporatorExchangerDriver.this)
			Thrust_WindowClosing(event);
		}
	}

	void Thrust_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JButton bInitialSettings = new javax.swing.JButton();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel13 = new javax.swing.JLabel();
	javax.swing.JTextField AdesignEch_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JTextField UAech_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JTextField AcalculatedEch_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField U_value = new javax.swing.JTextField();
	javax.swing.JTextField AdesignCond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel16 = new javax.swing.JLabel();
	javax.swing.JTextField UAcond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JTextField AcalculatedCond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	javax.swing.JTextField Ucond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabelFluid = new javax.swing.JLabel();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bInitialSettings)
				bInitialSettings_actionPerformed(event);
			
			
			
			
		}
	}

	public void init(){
		isInitialized=true;
		proj=getProjet();
		setupProject();
		
        //initializations for the simulation 
        //watch out: the names of points and components must be correct, otherwise an error will occur and prevent the TechnoDesign to be instanciated
        hxName="Exchanger";
        hotUpstream=new PointThopt(proj,"arrivee puits");
        hotDownstream=new PointThopt(proj,"retour puits");
        coldUpstream=new PointThopt(proj,"sortie pompe");
        coldDownstream=new PointThopt(proj,"entree turbine");
        
	    //instantiation of the TechnoDesign in the external class
		technoExchanger=new TechnoEvaporator(proj, hxName, hotUpstream, hotDownstream, coldUpstream, coldDownstream);
		technoExchanger.readCaract(echSettings);
		addTechnoVector(technoExchanger);
		
		JLabelFluid.setText("Fluide : "+coldUpstream.corps.name);

		
		condName="condenseur";
		condUpstream=new PointThopt(proj,"2turbine");
		condDownstream=new PointThopt(proj,"3condens");
		coldWaterInlet=new PointThopt(proj,"eau froide");
		coldWaterOutlet=new PointThopt(proj,"2froid");


		technoCondenser=new TechnoCondensor(proj, condName, condUpstream, condDownstream, coldWaterInlet, coldWaterOutlet);
		if(!condSettings.equals(""))technoCondenser.readCaract(condSettings);
		addTechnoVector(technoCondenser);

	    //initialization of the TechnoDesign in Thermoptim
		setupTechnoDesigns(vTechno);
	}
	
	void bInitialSettings_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	                            
        String[] args=new String[2];
        args[0]="project";
        args[1]="";
        Vector vProp=proj.getProperties(args);
        String flowUnit=(String)vProp.elementAt(0);
        if(!flowUnit.equals("kg/s")){
	        String msg = "Watch out! the flow rate unit should be\"kg/s\".\nYou may have discrepancies between your units \nand those used for heat exchanger design";
	        JOptionPane.showMessageDialog(this, msg);  
        }
        
	    if(!hxName.equals("")){//initialization of the heat exchanger
            args=new String[2];
            args[0]="heatEx";
            args[1]=hxName;
            vProp=proj.getProperties(args);
            Double f=(Double)vProp.elementAt(15);
            UAech=f.doubleValue();
            
            hotUpstream.getProperties();
            hotDownstream.getProperties();
            coldUpstream.getProperties();
            coldDownstream.getProperties();
	        
	        //TechnoDesign initializations
	        technoExchanger.UA=UAech;
	        technoExchanger.makeDesign();
	        
	        //display
	        U_value.setText(Util.aff_d(technoExchanger.getU(),4));
            UAech_value.setText(Util.aff_d(UAech,4));
	        AechReel=Util.lit_d(technoExchanger.ADesign_value.getText());
	        AcalculatedEch_value.setText(Util.aff_d(AechReel,4));
	    }
	    
	    if(!condName.equals("")){//initialization of the heat exchanger
            args=new String[2];
            args[0]="heatEx";
            args[1]=condName;
            vProp=proj.getProperties(args);
            Double f=(Double)vProp.elementAt(15);
            UAcond=f.doubleValue();
//    	    PointThopt condUpstream, condDownstream, coldWaterInlet, coldWaterOutlet;
            
            condUpstream.getProperties();
            condDownstream.getProperties();
            coldWaterInlet.getProperties();
            coldWaterOutlet.getProperties();
	        
	        //TechnoDesign initializations
            technoCondenser.UA=UAcond;
            technoCondenser.makeDesign();
	        
	       //display
	        Ucond_value.setText(Util.aff_d(technoCondenser.getU(),4));
            UAcond_value.setText(Util.aff_d(UAcond,4));
	        AcondReel=Util.lit_d(technoCondenser.ADesign_value.getText());
	        AcalculatedCond_value.setText(Util.aff_d(AcondReel,4));
	    }

	        
	}
	

	    
	public void transferTechnoData(String ligne_data){
	    if(ligne_data!=null)technoDesignData=ligne_data;
	    init();
	}
	
	void setupPilot(String ligne_data){
	    Vector vSettings=new Vector();
	    StringTokenizer st = new StringTokenizer(ligne_data,"\n");
	    while(st.hasMoreTokens()){
	        String ligne=st.nextToken();
		    String type=Util.extr_value(ligne,"compType");
		    String comp=Util.extr_value(ligne,"component");
		    String value="";
		    if(type.equals("HeatEx")){//3 lignes dans ce cas
		        value=Util.extr_value(ligne,"ADesign_value");
		        if(comp.equals(hxName)){
		            if(!(value==null)){
		                AdesignEch=Util.lit_d(value);
	                    AdesignEch_value.setText(Util.aff_d(AdesignEch,4));
	                    technoExchanger.ADesign_value.setText(value);
	                }
	                ligne=st.nextToken();
		            technoExchanger.techc.readCompParameters(ligne);
	                ligne=st.nextToken();
		            technoExchanger.techf.readCompParameters(ligne);
		            Object[]obj=new Object[3];
		            obj[0]=comp;
		            obj[1]=type;
		            obj[2]=technoExchanger;
		            vSettings.addElement(obj);
		        }
		    }
		    else{//autres TechnoDesign
		    }
	    }
		proj.bindTechnoDesigns(vSettings);
	    
	}


	public void readCompParameters(String ligne_data){
	    String value="";
	    value=Util.extr_value3(ligne_data, "technoExchanger");
		if(!(value==null)){
			echSettings=value;
		    if(technoExchanger!=null)technoExchanger.readCaract(echSettings);
	    }
	    value=Util.extr_value3(ligne_data, "technoCondenser");
		if(!(value==null)){
			condSettings=value;
		    if(technoCondenser!=null)technoCondenser.readCaract(condSettings);
	    }
		
	}
	
    public String saveCompParameters(){
	    String h="";
	    if((technoExchanger==null)||(technoCondenser!=null))//Cas o le modle n'a pas t rinitialis (et donc les TechnoDesign pas modifis)
	    	h=h+"#technoExchanger="+echSettings+"#"+tab+"#technoCondenser="+condSettings+"#"+tab;
	    else//cas normal
		    h=h+"#technoExchanger="+technoExchanger.saveCaract()+"#"+tab
		    +"#technoCondenser="+technoCondenser.saveCaract()+"#"+tab;
        return h;
    }


}