/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import java.util.*;


public class FlowConfig 
{
    TechnoExch te;
    TechnoExch otherTe;
    String NuCorrel="",fCorrel="";
 	protected  String tab=new String("\t");
	protected  String ligne=new String("\n");
	protected double Nu;
	boolean specialCalculation=false;
	public double C1,a_Re,b_Pr,c_Visc,C2,d_Re,RR;
	public String pdcCorrel="";
	boolean internalSetting=false;
	double laminarLimit=2000,turbulentLimit=8000;
	public boolean laminar=false,colebrook=true, diph=true;
	public double NuLamin=7;
	public double gliss, voidFraction, ro_m, Kh=1;//calculs du taux de vide

    public FlowConfig (){
    }

    public FlowConfig (TechnoExch te){
        this.te=te;
		te.JLabel13.setText("length");
		otherTe=te.otherTe;
		setParameterValues();//modRG 07/2012
    }
    void setParameterValues(){//modRG 07/2012
        C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;RR=0.001;
        C2=0.31;d_Re=-0.25;    	
    }
    
    public void setTechnoExch(TechnoExch te){
        this.te=te;
        C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;RR=0.001;;
        C2=0.31;d_Re=-0.25;
		te.JLabel13.setText("length");
		otherTe=te.otherTe;
    }
    
    public String getCode(){return "flow config";}
    
	public String getClassDescription(){
	    return "basic class for flow configuration";
	}
            
	public double calcNu(double P){
	    return calcNuTube();
	}
    public double calcNuTube(){//Implmentation par dfaut
  /*      Corps lecorps=te.corps;
        double x=te.comp.amont.getXx();
        double Tthis=(te.comp.amont.getT()+te.comp.aval.getT())/2;
        te.initLambdaMu(Tthis, x, lecorps);
  
        //bulk viscosity
        double viscCorr=te.mu;
        
        //wall viscosity
        ExchangeDemo otherComp=te.hX.hotFluid;
        if(te.comp==te.hX.hotFluid)otherComp=te.hX.coldFluid;
        double Tother=(otherComp.amont.getT()+otherComp.aval.getT())/2;
        // wall temperature
        double Twall=(Tother+Tthis)/2.;
        te.initLambdaMu(Twall, x, lecorps);
   //     System.out.println("Tthis "+Tthis+"  viscosity "+viscCorr);
        viscCorr=viscCorr/te.mu;*/
 //       if(te.getRe()<2000)return 4.;
        calcMeanDensity(te.amont.V, te.aval.V, te.amont.X, te.aval.X);
        if(laminar){//si prise en compte laminaire
//	        te.Re=turbulentLimit;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
//	        te.Re=te.calcRe();
	        double Re=te.getRe();
	        if(Re<=laminarLimit)return Nul;
	        else if(Re>=turbulentLimit)return C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            return Nul+(Nut-Nul)*alpha;
	        }
	    }
	    else return C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);//*Math.pow(viscCorr,c_Visc);
    }
    
    protected double getNuLamin(){
        return NuLamin;
    }
    
	public double getNusselt(){return Nu;}
	
	public double calcDP(){
	    return calcDP(te.amont.V);
	}
	
	public double calcDP(double vl){
		//if(!diph)te.sf.maskPdcCorrel();
	    double dP;
	    double flow=te.getFlow();
	    double Ac=Util.lit_d(te.Ac_value.getText());
	    double dh=Util.lit_d(te.Dh_value.getText());
	    double L=Util.lit_d(te.L_value.getText());
	    double f=getFrictionFactor();
	    double C=flow*vl/Ac;
	    te.frictionFactor_value.setText(Util.aff_d(f,6));
	    dP=f*vl/2*flow*flow/Ac/Ac*L/dh/100000;//Perte rgulire en bar
/*	    double dPSing=Util.lit_d(te.dPSing_value.getText())*C*C/2/vl/100000;//Perte singulire en bar
	    double dPSing=Util.lit_d(te.dPSing_value.getText())*vl/2*flow*flow/100000;//Perte singulire en bar
//	    System.out.println(te.getRe()+"\t"+te.mu+"\t"+RR+"\t"+C+"\t"+f+"\t"+dPSing+"\t"+dP);
	    dP=dP+dPSing;*/
	    return dP;
    }
/*
	public double calcDPdiff(){
        double Tsat=te.corps.lecorps.getSatTemperature(te.amont.P, 1);//pression d'vaporation
	    te.corps.lecorps.CalcPropCorps(Tsat,te.amont.P,1.);
	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
	    
	    return calcDP(v);
	}
*/
	public double calcDPdiff(){
        double Tsat=te.corps.lecorps.getSatTemperature(te.amont.P, 0);//pression d'vaporation
	    te.corps.lecorps.CalcPropCorps(Tsat+0.1,te.amont.P,0);
	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
        double ro_v=1/v;
	    te.corps.lecorps.CalcPropCorps(Tsat-0.1,te.amont.P,0);
	    vProp=te.corps.lecorps.getSubstProperties();
        f=(Double)vProp.elementAt(3);
        v=f.doubleValue();
        double ro_l=1/v;
	    double dPl=calcDP(v);
	    
	    te.initLambdaMu(Tsat, te.amont.P, 0);
	    double mu_l=te.mu;
	    double sigma=te.sigma;
	    te.initLambdaMu(Tsat, te.amont.P, 1);
	    double mu_v=te.mu;
	    
	    double G= te.getFlow()/Util.lit_d(te.Ac_value.getText());//vitesse massique
	    double Re_l=G/te.mu_l*Util.lit_d(te.Dh_value.getText());//nombre de Reynolds
	    double Re_v=G/te.mu_g*Util.lit_d(te.Dh_value.getText());//nombre de Reynolds
	    double f_la=getMSHFrictionFactor(Re_l);
	    double f_va=getMSHFrictionFactor(Re_v);
	    double L=Util.lit_d(te.L_value.getText());
	    
//	    f_la=getFrictionFactor(Re_l);
//	    f_va=getFrictionFactor(Re_v);

	    double dPz_la=f_la/2*G*G/ro_l/Util.lit_d(te.Dh_value.getText())/100000;
	    double dPz_va=f_va/2*G*G/ro_v/Util.lit_d(te.Dh_value.getText())/100000;
	    
	    double dPz=0;	    
	    double F=0;
		double dPv=0;
	    double dPlv=0;

	    boolean test=false;
	    
	    //Corrlation de Mller-Steinhagen and Heck correlation
		if((pdcCorrel.equals("Mller-Steinhagen & Heck"))||test){
			for(int i=0;i<100;i++){
				double x=te.amont.X+i/100.*(te.aval.X-te.amont.X);
				double ff=(dPz_la+2*(dPz_va-dPz_la)*x)*Math.pow(1-x, 1./3.)+dPz_va*Math.pow(x, 3.);
				dPz=dPz+ff*0.01;
			}
	//		double F_MSH=dPz/dPz_la;
			F=dPz/dPz_la;
			dPl=dPz_la*L;
		    dPlv=F*dPl;
			dPv=dPz_va*L;

			System.out.println("dPz_la\t"+dPz_la+"\tdPz_va\t"+dPz_va+"\tF\t"+F
					+"\tdPl\t"+dPl+"\tdPv\t"+dPv);
			System.out.println("Corrlation de Mller-Steinhagen and Heck\t"+"\tF\t"+F);
		}
		
		//Corrlation de Sun et Mishima
	//	double F_SM=0;
		double mu=Math.pow(te.mu_l/te.mu_g, -0.1);
		double ro=Math.pow(ro_l/ro_v, 0.5);
		if((pdcCorrel.equals("Sun & Mishima"))||test){
			F=0;
		    double X22=0;
			for(int i=1;i<100;i++){
				double x=te.amont.X+i/100.*(te.aval.X-te.amont.X);
//				double x=i/100.;
			    double Re_lo=G*(1-x)/te.mu_l*Util.lit_d(te.Dh_value.getText());//nombre de Reynolds
			    double f_lo=getMishimaFrictionFactor(Re_lo);
			    double Re_go=G*x/te.mu_g*Util.lit_d(te.Dh_value.getText());//nombre de Reynolds
			    double f_go=getMishimaFrictionFactor(Re_go);
			    //Attention : f est exprim de manire homogne avec les autres corrlations 
			    //par des valeurs 4 fois plus importantes que dans Thome et Cioncolini
			    double dPz_lo=f_lo/2*G*G*(1-x)*(1-x)/ro_l/Util.lit_d(te.Dh_value.getText())/100000;
			    X22=Math.pow(f_lo/f_go, 0.5)*(1-x)/x/ro;
				double C=1.79*Math.pow(X22,-0.19)*Math.pow(1/x-1, 0.1)*Math.pow(te.mu_l/te.mu_g,0.4);
	//			System.out.println("X22\t"+X22+"\tC\t"+C);
				double ff=1+C/X22+1/X22/X22;
//				F=F+dPz_lo*ff/99./dPz_la;
				dPz=dPz+dPz_lo*ff/99.;
			}
			F=dPz/dPz_la;
			dPl=dPz_la*L;
		    dPlv=F*dPl;
			dPv=dPz_va*L;
			
			System.out.println("Corrlation de Sun et Mishima\t"+"\tF\t"+F);
		}
		
		
		if((pdcCorrel.equals("Herer"))||test){
			
	//		double F_H=0;
			F=0;
			//Corrlation de Herer
		    double z= (1+Math.abs(te.aval.X-te.amont.X)*(ro_l/ro_v-1));
		    double y=(1+Math.abs(te.aval.X-te.amont.X)*(te.mu_l/te.mu_g-1));
	//	    double z= (1+Math.abs(te.aval.X-te.amont.X)*(te.ro_l/te.ro_v-1));
	//	    double z= (1+(te.aval.X+te.amont.X)/2.*(te.ro_l/te.ro_v-1));
	//	    double y=(1+(te.aval.X+te.amont.X)/2.*(te.mu_l/te.mu_v-1));
	 //       System.out.println(te.exchangeName+"  te.amont.X "+te.amont.X+"  te.aval.X "+te.aval.X);	        
	        System.out.println(te.exchangeName+"  z "+z+"  te.ro_l "+ro_l+"  te.ro_v "+ro_v);	        
	        System.out.println(te.exchangeName+"  y "+y+"  te.mu_l "+te.mu_l+"  te.mu_v "+te.mu_g);	        
		    y=Math.pow(y, -0.2);
		    F=z*y;
			System.out.println("Corrlation de Herer\t"+"\tF\t"+F);
		    
	/*	    System.out.println("dPl\t"+dPl+"\tF\t"+F);
		    F=0;
			for(int i=0;i<100;i++){
				double x=i/100.;
				double mu=te.mu_l/te.mu_v;
				double ro=ro_l/ro_v;
				z=(1+x*(ro-1));
				y=(1+x*(mu-1));
			    y=Math.pow(y, -0.2);
				double ff=z*y;
				F=F+ff*0.01;
			}*/
		    
		    System.out.println("dPl\t"+dPl+"\tF_H\t"+F);
			dPl=dPz_la*L;
		    dPlv=F*dPl;
			dPv=dPz_va*L;
		}
	    
		if((pdcCorrel.equals("Lockhart-Martinelli"))||test){
	    
	    //Corrlation de Lockart-Martinelli
	//    double F_LM=0;
			F=0;
		    double Xtt=0;
			mu=Math.pow(te.mu_l/te.mu_g, -0.1);
			ro=Math.pow(ro_l/ro_v, 0.5);
			for(int i=0;i<100;i++){
				double x=te.amont.X+i/100.*(te.aval.X-te.amont.X);
//				double x=i/100.;
				Xtt=Math.pow((1-x)/x, 0.9)/ro/mu;
				double ff=Math.pow(1-x, 1.8)*(1+20/Xtt+1/Xtt/Xtt);
				F=F+ff*0.01;
			}
			System.out.println("Corrlation de Lockart-Martinelli TA\t"+"\tF\t"+F);		
			dPl=dPz_la*L;
		    dPlv=F*dPl;
			dPv=dPz_va*L;
		}
		
		if((pdcCorrel.equals("Friedel"))||test){
			//Corrlation de Friedel			
		    f_la=getMSHFrictionFactor(Re_l);			
		    dPz_la=f_la/2*G*G/ro_l/Util.lit_d(te.Dh_value.getText())/100000;
		    dPz=0;
			for(int i=0;i<100;i++){
				double x=te.amont.X+i/100.*(te.aval.X-te.amont.X);
//				double x=i/100.;
				double A1=(1-x)*(1-x)+x*x*ro_l/ro_v*f_va/f_la;
			    double A2=Math.pow(x,0.78)*Math.pow(1-x,0.224);
			    double A3=Math.pow(ro_l/ro_v,0.91)*Math.pow(mu_v/mu_l,0.19)*Math.pow(1-mu_v/mu_l,0.7);
	
			    double ro_h=1/((1-x)/ro_l+x/ro_v);
			    double Fr=G*G/ro_h/ro_h/9.81/Util.lit_d(te.Dh_value.getText());
			    double We=G*G*Util.lit_d(te.Dh_value.getText())/ro_h/sigma;
			    double phi2_la=A1+3.24*A2*A3/Math.pow(Fr,0.045)/Math.pow(We,0.035);
				dPz=dPz+phi2_la*dPz_la*0.01;
			}
			
//		    double F_fr=dPz/dPz_la;
		    F=dPz/dPz_la;
			dPl=dPz_la*L;
			dPv=dPz_va*L;
		    dPlv=F*dPl;

			System.out.println("dPz_la\t"+dPz_la+"\tdPz_va\t"+dPz_va+"\tF_fr\t"+F
					+"\tdPl\t"+dPl+"\tdPv\t"+dPv);
			System.out.println("Corrlation de Friedel\t"+"\tF\t"+F+"\tsigma\t"+sigma);
		}
	    if(te.amont.X<te.aval.X){//vaporation
	    	dPl=calcDP(te.amont.V);
	    	dPv=calcDP(te.aval.V);
	    	//on masque le JComboBox de la transfo chaude monophasique
			te.tHx.techc.sf.maskPdcCorrel();
	        System.out.println("Correl vaporation "+pdcCorrel+"\tF\t"+F+" dPl\t"+dPl+"\tdPv\t"+dPv+"\tdPlv\t"+dPlv);	        
	    }
	    else {//condensation
	    	dPl=calcDP(te.aval.V);
	    	dPl=calcDP(te.amont.V);
	    	//on masque le JComboBox de la transfo froide monophasique
			te.tHx.techf.sf.maskPdcCorrel();
	        System.out.println("Correl condensation "+pdcCorrel+"\tF\t"+F+" dPl\t"+dPl+"\tdPv\t"+dPv+"\tdPlv\t"+dPlv);	        
	    }

	    double zz=0;//deux cas selon qu'il s'agit d'un changeur ou d'un thermocoupleur
	    if(te.tHx!=null)zz=te.tHx.Al/te.tHx.A*dPl+te.tHx.Alv/te.tHx.A*dPlv+te.tHx.Av/te.tHx.A*dPv;
	    if(te.tTc!=null)zz=te.tTc.Al/te.tTc.A*dPl+te.tTc.Alv/te.tTc.A*dPlv+te.tTc.Av/te.tTc.A*dPv;

	    return zz;
	}

/*	public double getMSHFrictionFactor(double Re){
	    if(Re>1187)return 0.0791*Math.pow(Re,-0.25);
	    else return 16/Re;
    }*/
	/* Version alternative de la formule de Blasius
	 * exprime de manire homogne avec getFrictionFactor
	 * (ce qui explique le facteur 4 par rapport aux publications)
	 */

	public double getMSHFrictionFactor(double Re){
	    if(Re>1187)return 0.316*Math.pow(Re,-0.25);
	    else return 64/Re;
    }

/*
	public void calcG(){
	    G= getFlow()/Util.lit_d(Ac_value.getText());//vitesse massique
	}
	public double getG(){
	    return G;//vitesse massique
	}
	//Nombre de Reynolds
	public double getRe(){
	    return Re;//nombre de Reynolds
	}
	public void calcRe(){
//	    Re=4./Math.PI*G/mu*Util.lit_d(Dh_value.getText());//nombre de Reynolds
	    Re=G/mu*Util.lit_d(Dh_value.getText());//nombre de Reynolds
//        System.out.println("CalcReTechnoExch "+corps.name + " mu : "+mu+ " G : "+G+ " Re : "+Re );
	}
	//Nombre de Prandtl
	public void calcPr(double Cp){
	    Pr= 1000.*Cp*mu/lambda;//nombre de Prandtl en kJ/kg/K
	}
	public double getPr(){
	    return Pr;//nombre de Prandtl en kJ/kg/K
	}
*/
	public double getFrictionFactor(double Re){
	    //=te.getRe();
	    if(Re>2300){
	        if(colebrook){
	            double y=Math.pow(RR/3.71, 1.1);
	            double z=-0.781730067*Math.log(y+6.9/Re);
	            double f=1/z/z;
	            return f;
	        }
	        else{
	            return C2*Math.pow(Re, d_Re);
	        }
	    }
	    else{
	        return 64/Re;
	    }
	/*    if(Re>5000){
	    	return 0.314*Math.pow(Re,-0.25);
	    }
	    else if((Re<5000)&&(Re>3000)){
	    	return 64/5000*(5000-Re)/2000+0.314/Math.pow(5000,0.25)*(Re-3000)/2000;
	    }
	    else{
	        return 64/Re;
	    }*/

    }
	
	public double getFrictionFactor(){
	    double Re=te.getRe();
/*	    if(Re>2300){
	        if(colebrook){
	            double y=Math.pow(RR/3.71, 1.1);
	            double z=-0.781730067*Math.log(y+6.9/Re);
	            double f=1/z/z;
	            return f;
	        }
	        else{
	            return C2*Math.pow(Re, d_Re);
	        }
	    }
	    else{
	        return 64/Re;
	    }*/
	    if(Re>5000){
	    	return 0.314*Math.pow(Re,-0.25);
	    }
	    else if((Re<5000)&&(Re>3000)){
	    	return 64/5000*(5000-Re)/2000+0.314/Math.pow(5000,0.25)*(Re-3000)/2000;
	    }
	    else{
	        return 64/Re;
	    }

    }
	public double getMishimaFrictionFactor(double Re){
	    if(Re>2000){
	    	return 0.314*Math.pow(Re,-0.25);
	    }
	    else{
	        return 64/Re;
	    }

    }

	
	public double getPressFactor(){
	    return 1;
    }
	public void setPressFactor(double fact){
    }
    
	//permet de faire un test de cohrence associ  une config 
	//par exemple, une tour de refroidissement ncessite de l'air comme corps
    public boolean testeConfig(){
        return true;
    }
    
	 //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	 public void calcMeanDensity(double Vl, double Vv,double Xe,double Xs){
	        double fact=Vv/Vl;
	        if(Vv>Vl){//appel normal
	            gliss=Math.pow(fact,1./3.);//glissement S selon Zivi
    //	        voidFraction=Kh/(1.+gliss*(1.-te.amont.X)/te.amont.X/fact);//valeur au point amont
    //	        ro_m=voidFraction/Vv+(1.-voidFraction)/Vl;//valeur au point amont
                //calcul de la valeur moyenne de ro_m (intgration de l'quation prcdente)
	            double a, b, c;
	            a=Kh/Vl*(1./Vv-1./Vl);
	            b=1./Vl-gliss/Vv;
	            c=gliss/Vv;
	            ro_m=Math.abs((1./Vl+a/b)*(Xe-Xs)-a*c/b/b*Math.log((Xe+c/b)/(Xs+c/b)));
	        }
	        else if(Vv<Vl){//appel invers au cas o on entre en vapeur et sort en liquide
	            fact=1/fact;
	            double V=Vl;
	            Vl=Vv;
	            Vv=V;
	            gliss=Math.pow(fact,1./3.);//glissement S selon Zivi
    //	        voidFraction=Kh/(1.+gliss*(1.-te.amont.X)/te.amont.X/fact);//valeur au point amont
    //	        ro_m=voidFraction/Vv+(1.-voidFraction)/Vl;//valeur au point amont
                //calcul de la valeur moyenne de ro_m (intgration de l'quation prcdente)
	            double a, b, c;
	            a=Kh/Vl*(1./Vv-1./Vl);
	            b=1./Vl-gliss/Vv;
	            c=gliss/Vv;
	            ro_m=Math.abs((1./Vl+a/b)*(Xe-Xs)-a*c/b/b*Math.log((Xe+c/b)/(Xs+c/b)));
	        }
	        else{//cas monophasique
	            ro_m=1/Vl;
	        }
     }
	
	public double getMeanDensity(){
	    return ro_m;
	}
	/*
	
	public double get_f(){//facteur de frottement
//	    return 0.046*Math.pow(Re, 0.2);
	 //   return 0.03;
	    if(te.getRe()<2000)return 14./te.getRe();
	    else return 0.03;
	}
	*/
	public void readCompParameters(String ligne_data){
    //    C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;
        String valeur;
        valeur=Util.extr_value(ligne_data, "C1");
        if(valeur!=null)C1=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "a_Re");
        if(valeur!=null)a_Re=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "b_Pr");
        if(valeur!=null)b_Pr=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "c_Visc");
        if(valeur!=null)c_Visc=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "C2");
        if(valeur!=null)C2=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "d_Re");
        if(valeur!=null)d_Re=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "RR");
        if(valeur!=null)RR=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "Kh");
        if(valeur!=null)Kh=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "colebrook");
        if(valeur!=null)colebrook=Util.lit_b(valeur);
        valeur=Util.extr_value(ligne_data, "laminar");
        if(valeur!=null)laminar=Util.lit_b(valeur);
        valeur=Util.extr_value(ligne_data, "laminarNu_value");
   //     if(valeur!=null)te.sf.laminarNu_value.setText(valeur);
        if(valeur!=null)NuLamin=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "pdcCorrel_value");
        if(valeur!=null)pdcCorrel=valeur;
	}
	public void readCaract(String ligne_data){
    //    C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;
        String valeur;
        valeur=Util.extr_value2(ligne_data, "C1");
        if(valeur!=null)C1=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "a_Re");
        if(valeur!=null)a_Re=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "b_Pr");
        if(valeur!=null)b_Pr=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "c_Visc");
        if(valeur!=null)c_Visc=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "C2");
        if(valeur!=null)C2=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "d_Re");
        if(valeur!=null)d_Re=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "RR");
        if(valeur!=null)RR=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "Kh");
        if(valeur!=null)Kh=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "laminarNu_value");
//        if(valeur!=null)te.sf.laminarNu_value.setText(valeur);
        if(valeur!=null)NuLamin=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "pdcCorrel_value");
        if(valeur!=null)pdcCorrel=valeur;

	}
    public String saveCaract(){
	    String h;
        h="C1="+Util.aff_d(C1)+":"
        +"a_Re="+Util.aff_d(a_Re)+":"
        +"b_Pr="+Util.aff_d(b_Pr)+":"
        +"c_Visc="+Util.aff_d(c_Visc)+":"
        +"C2="+Util.aff_d(C2)+":"
        +"d_Re="+Util.aff_d(d_Re)+":"
        +"RR="+Util.aff_d(RR)+":"
        +"Kh="+Util.aff_d(Kh)+":"
        +"colebrook="+Util.aff_b(colebrook)+":"
        +"laminar="+Util.aff_b(laminar)+":"
        +"laminarNu_value="+te.sf.laminarNu_value.getText()+":"
        +"pdcCorrel_value="+pdcCorrel+":"        
        
        ;
        return h;
    }
    public String saveCompParameters(){
	    String h;
        h="C1="+Util.aff_d(C1)+"\t"
        +"a_Re="+Util.aff_d(a_Re)+"\t"
        +"b_Pr="+Util.aff_d(b_Pr)+"\t"
        +"c_Visc="+Util.aff_d(c_Visc)+"\t"
        +"C2="+Util.aff_d(C2)+"\t"
        +"d_Re="+Util.aff_d(d_Re)+"\t"
        +"RR="+Util.aff_d(RR)+"\t"
        +"Kh="+Util.aff_d(Kh)+"\t"
        +"colebrook="+Util.aff_b(colebrook)+"\t"
        +"laminar="+Util.aff_b(laminar)+"\t"
        +"laminarNu_value="+te.sf.laminarNu_value.getText()+"\t"
        +"pdcCorrel_value="+pdcCorrel+"\t"
       ;
        return h;
    }


}