/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import extThopt.AirExchangerDriver.SymAction;
import rg.thopt.*;


public class TechnoCSG extends TechnoSteamGenerator
{
	public TechnoCSG()
	{
        super();
    }
	public TechnoCSG(Projet proj, String hXname, PointThopt amontHot, PointThopt avalHot, PointThopt amontCold, PointThopt avalCold)
	{
	    super(proj, hXname, amontHot, avalHot, amontCold, avalCold);
	    corps=new CorpsThopt(proj, amontCold.nomCorps, amontCold.lecorps);
    //	debug=true;
	    Al=300;Alv=2100;Av=400;
	    A=Al+Alv+Av;
		JLabel6.setText("q_pb exp.");

        type=getType();
    }
	

	public TechnoCSG(Projet proj, String hXname)
	{
	    super(proj, hXname);
	    corps=new CorpsThopt(proj, techf.amont.nomCorps, techf.amont.lecorps);
   // 	debug=true;

    }
  	public String getClassDescription(){
	    return "CSG evaporator class\n\nauthor : R. Gicquel  december 2020\n\nRef : archive ";
	}
	
    public String getType(){
        return "CSG evaporator";
    }
    public String getCompType(){
        return "CSG evaporator";
    }
    public String getClassName(){
        return "TechnoCSG";
    }
    

	public double getFrictionFactor(double Re){
	    if(Re>5000){
	    	return 0.314*Math.pow(Re,-0.25);
	    }
	    else if((Re<5000)&&(Re>3000)){
	    	return 64/5000*(5000-Re)/2000+0.314/Math.pow(5000,0.25)*(Re-3000)/2000;
	    }
	    else{
	        return 64/Re;
	    }
    }
  
public double calcNuUlf(double P){//Implmentation CEDRIC avec bullition nucle
	double Tc=0;
	double Tf=0;
	double Tsat=Tfl;
	double NUT_f=0;
    double h=1e4;
    double h_f=0;
    double h_c=0;
    double delta=0;
    double twall=0;
    //Corrlation de Forster-Geist
    double h_FG=1000/2.16*Math.pow(ql/1000, 0.65)*Math.pow(P,0.23);
    //Surchauffe en paroi dduite de Forster-Geist
    double dTsat=2.16*Math.pow(ql/1000, 0.35)*Math.pow(P,-0.23);

	  boolean firstEntry=true;
	  int entryIndex=-1;
	  double q_pb=0;
	  int count=0;
	  double dTonb=0;
	  for(int i=99;i>0;i--){
			//l'changeur est dcoup en 100 parties et 
			// les diffrents quilibres sont calculs
			double x=i/99.;	
			Tc= Tcl-(Tcl-Tcs)*x;
			Tf= Tfl-(Tfl-Tfe)*x;
			
			//attention,  retravailler
		    techf.initLambdaMu(Tf,  P_fe, 0);
			double h_db=techf.fc.C1*Math.pow(techf.getRe(),techf.fc.a_Re)*Math.pow(techf.getPr(),techf.fc.b_Pr)/Util.lit_d(techf.Dh_value.getText())*techf.lambda;
		    techc.initLambdaMu(Tc, Pc_inlet, 0);
			h_c=techc.fc.C1*Math.pow(techc.getRe(),techc.fc.a_Re)*Math.pow(techc.getPr(),techc.fc.b_Pr)/Util.lit_d(techc.Dh_value.getText())*techc.lambda;
	
			//temprature de paroi
	        double Rt=1/h+Util.lit_d(techf.tHx.eLambda_value.getText())+1/h_c;
	        double Twall=Tc/h/Rt+(1-1/h/Rt)*Tf;
	        twall=Twall-273.15;
	        
			//Ecoulement liquide avec bullition locale
	        //retard de dTonb
	        double fp=Math.pow(Psat,1.156);
	        double exp2=Math.pow(Psat,0.0234)/2.16;
	        double dTonb_b=5./9*Math.pow(9.23*ql/1e4/fp,exp2);//Berles
//	        System.out.println("Berles "+"  dTonb "+dTonb);
	        double dTonb_jl=22.65*Math.pow(ql/1e6,0.25)*Math.exp(-P/62.);//Jens Lottes 7,8 C
//	        System.out.println("Jens Lottes "+"  dTonb "+dTonb);
	        double hL=h_db;//Nu_db/dh*lambda;
//	        double fact2=1+techf.lambda*Lf*1000*(Tsat-Tf)/2/techf.getSurfaceTension(Tf)/Tsat/(1/techf.ro_g-1/techf.ro_l)/hL;
	        double fact2=1+techf.lambda*Lf*1000*(Tsat-Tf)/2/techf.sigma/Tsat/(1/techf.ro_g-1/techf.ro_l)/hL;
	        fact2=Math.pow(fact2, 0.5);
	        
	        //Kandlikar
//	        double dTonb_k=4.*techf.getSurfaceTension(Tf)*Tsat*(1/techf.ro_g-1/techf.ro_l)*hL/techf.lambda/Lf/1000*(1+fact2);	        
	        double dTonb_k=4.*techf.sigma*Tsat*(1/techf.ro_g-1/techf.ro_l)*hL/techf.lambda/Lf/1000*(1+fact2);	        
	        
	        //On retient la corrlation de Thom
	        double dTonb_th=25.*Math.pow(ql/1e6,0.5)*Math.exp(-P/87.);//Thom 6,5 C
	        
			//max des valeurs
	        dTonb=dTonb_b;
	        if(dTonb_jl>dTonb)dTonb=dTonb_jl;
	        if(dTonb_k>dTonb)dTonb=dTonb_k;
	        if(dTonb_th>dTonb)dTonb=dTonb_th;
	        
	        //moyenne des valeurs
	        dTonb=(dTonb_b+dTonb_jl+dTonb_k+dTonb_th)/4.;
	        
	        delta=Twall-Tsat-dTonb;
	        
			if(delta>0){
				count++;
				if(firstEntry)entryIndex=i;
				firstEntry=false;
				double x_onb=entryIndex/99.;
				//x2 est l'abscisse rduite entre ONB et FDB
				double x2=1.-x/x_onb;
		        double R=(Twall-Tsat)/(Twall-Tf);	
		        //h_nb =  h_FG * x2^6
		        //On pourrait amliorer les choses en maintenant le fdb au-del du sous-
		        //refroidissement o le FDB est atteint (5% environ de l'changeur)
		        //x2 serait calcul entre x_onb et x_fdb, puis maintenu gal  1 entre
		        //x_fdb et 1
	//	    	h=h_db*(1-R)+h_FG*R*Math.pow(x2,Util.lit_d(A_value.getText()));//CEDRIC
		    	h=h_db+h_FG*R*Math.pow(x2,Util.lit_d(A_value.getText()));//Corrige
			  	q_pb=q_pb+h/99.*(Twall-Tsat);
//			  	System.out.println("x "+x+"  delta "+delta+"  x2 "+x2+"  R "+R+"  h "+h);
		        NUT_f=NUT_f+h*Util.lit_d(techf.Dh_value.getText())/techf.lambda/99.;
		        h_f=h_f+h/99.;
	        }
			else{//pas d'bullition locale
	//		  	System.out.println("x "+x+"  delta "+delta+"  h_db "+h_db+" NUT_f "+NUT_f);
			  	h=h_db;
			  	firstEntry=true;
				NUT_f=NUT_f+h_db*Util.lit_d(techf.Dh_value.getText())/techf.lambda/99.;
		        h_f=h_f+h/99.;
			}
		}
	   System.out.println("Tsat "+Tsat+"  dTonb "+dTonb+"  h_FG "+h_FG+" twall "+twall);
  	  	q_pb=q_pb/count;
//		NUT_f=NUT_f/(1+NUT_f*Util.lit_d(techf.tHx.eLambda_value.getText()));
		return NUT_f;
	  }

	    //Calculs de U vapeur, Corrlation de Colburn
	    public double getUv(double xc,double xf){
	        double u=1;
	        if((techc!=null)&&(techf!=null)){
	            calcNusseltUv((Tc_inlet+Tcv)/2., Pc_inlet, xc, mCpcv/mc, false, techc);
	            calcNusseltUv((Tfs+Tfv)/2., P_fv, xf, mCpfv/mf, false, techf);
	            u=get_U();
	           
	        	hvc=Util.aff_d(hc,2);
	        	hvf=Util.aff_d(hf,2);
	            JLabhvc.setText(resIntTh_fr.getString("hvc")+" = "+Util.aff_d(hc,2)+" Re = "+Util.aff_d(techc.Re,2));
	            JLabhvf.setText(resIntTh_fr.getString("hvf")+" = "+Util.aff_d(hf,2)+" Re = "+Util.aff_d(techf.Re,2));
	        }
	        return u;
	    }
		public void calcNusseltUv(double T, double P, double x, double Cp, 
			    boolean calcDP, TechnoExch te){
				te.initLambdaMu(T, P, x);
			    if(te.mu*te.lambda!=0){
			    	te.calcG();//vitesse massique
			    	te.calcPr(Cp);//nombre de Prandtl Cp en kJ/kg/K
			    	te.calcRe();//nombre de Reynolds
			    	te.Nu=calcNuUv(T, P, x, te);//le relais est pass  la FlowConfig
//			        double dP=fc.calcDP();
			    	te.calcH();
			    }
			    else{//message : lambda ou mu du fluide inconnu
				    String message="The conductivity or the viscosity is zero for fluid: "+corps.name;
		            message=message+"\nYou should check the corresponding external class";
		            JOptionPane.showMessageDialog(new JFrame(),message);
			    }
			}



		  public double calcNuUv(double T, double P, double x, TechnoExch te){//Implmentation par dfaut
		        te.initLambdaMu(T, P, x);
				double NUT=0.023*Math.pow(te.getRe(),0.8)*Math.pow(te.getPr(),1./3.);
	        	System.out.println("calcNuTube2 te.Pr vap "+te.getPr()+"  Re "+te.getRe()+"  NUT "+NUT);
			
				return NUT;
		  }
		
			public String saveSpecificParams(){
/*				String hvc=Util.extr_value(JLabhvc.getText(),"hvc");
				String hlvc=Util.extr_value(JLabhlvc.getText(),"hvc");
				String hlc=Util.extr_value(JLabhlc.getText(),"hvc");
				String hvf=Util.extr_value(JLabhvf.getText(),"hvc");
				String hlvf=Util.extr_value(JLabhlvf.getText(),"hvc");
				String hlf=Util.extr_value(JLabhlf.getText(),"hvc");*/
				String h="\tAl="+Util.aff_d(Al)+"\tAlv="+Util.aff_d(Alv)+"\tAv="+Util.aff_d(Av)
	    		+"\thvc="+hvc+"\thlvc="+hlvc+"\thlc="+hlc
	    		+"\thvf="+hvf+"\thlvf="+hlvf+"\thlf="+hlf
	    		+"\tp_dbExp="+A_value.getText();

				return h;
			}
			
			public void readSpecificParams(String ligne_data){
				String value=Util.extr_value2(ligne_data, "Al");
				if(!(value==null))Al=Util.lit_d(value);
		        value=Util.extr_value2(ligne_data, "Alv");
				if(!(value==null))Alv=Util.lit_d(value);
		        value=Util.extr_value2(ligne_data, "Av");
				if(!(value==null))Av=Util.lit_d(value);
		        value=Util.extr_value2(ligne_data, "p_dbExp");
	   //     	System.out.println("p_dbExp "+ligne_data);
				if(!(value==null))A_value.setText(value);			
			}
			

}