/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import rg.thopt.*;


public class TechnoCSG_sansDP extends TechnoEvaporator
{
	public TechnoCSG_sansDP()
	{
        super();
    }
	public TechnoCSG_sansDP(Projet proj, String hXname, PointThopt amontHot, PointThopt avalHot, PointThopt amontCold, PointThopt avalCold)
	{
	    super(proj, hXname, amontHot, avalHot, amontCold, avalCold);
	    corps=new CorpsThopt(proj, amontCold.nomCorps, amontCold.lecorps);
    //	debug=true;

    }
	public TechnoCSG_sansDP(Projet proj, String hXname)
	{
	    super(proj, hXname);
	    corps=new CorpsThopt(proj, techf.amont.nomCorps, techf.amont.lecorps);
   // 	debug=true;

    }
  	public String getClassDescription(){
	    return "CSG evaporator class\n\nauthor : R. Gicquel  december 2020\n\nRef : archive ";
	}
	
    public String getType(){
        return "CSG evaporator";
    }
    public String getCompType(){
        return "CSG evaporator";
    }
    public String getClassName(){
        return "TechnoCSG";
    }
	
    public void makeDesign(){//chaud en sensible, froid diphasique (vaporateur)
        resetHX();
 //   	System.out.println("makeDesign TechnoCSG ");

        Pfe=techf.amont.P;
        double Pfs=techf.aval.P;
        Tfl=corps.lecorps.getSatTemperature(Pfe,0);
        Tfv=corps.lecorps.getSatTemperature(Pfe,1);
	    corps.lecorps.CalcPropCorps(Tfl-0.1, Pfe, 0);
//	    System.out.println("corps "+corps.name+"  T "+Util.aff_d(Tfl-273.15)+"  Pfe "+Pfe);
	    corps.getSubstProperties();
	    corps.lecorps.CalcPropCorps(Tfl-0.1, Pfe, 0);
	    corps.getSubstProperties();
        double Hl=corps.H;
	    corps.lecorps.CalcPropCorps(Tfv+0.1, Pfe, 1);
	    corps.getSubstProperties();
        double Hv=corps.H;
 //       Tfl=Tfv-0.1;
        Lf=Hv-Hl;
        mCpflv=mf*Lf;   
/*        System.out.println("Tfl "+Tfl+"  Tfv "+Tfv+" corps.lecorps "+corps.name+" mCpflv "+mCpflv);
        System.out.println("Hl "+Hl+"  Hv "+Hv+" Tfl "+Tfl+" Tfv "+Tfv+" Pfe "+Pfe);
        
        //on estime les mCp liquide et vapeur indpendamment des tats des points amont et aval existants
	    corps.lecorps.CalcPropCorps(Tfv+10, Pfe, 1);
	    corps.getSubstProperties();
        mCpfv=mf*(corps.H-Hv)/10.;*/
	    corps.lecorps.CalcPropCorps(Tfs+2, Pfs, 1);//modRG 08/2009
	    corps.getSubstProperties();
        mCpfv=mf*(corps.H-techf.aval.H)/2.;
	    corps.lecorps.CalcPropCorps(Tfl-5, Pfe, 1);
	    corps.getSubstProperties();
        mCpfl=mf*(Hl-corps.H)/4.9;

        mCpclv=mCpc;        
        mCpcv=mCpc;
        mCpcl=mCpc;        
        //te.amont.X=te.amont.corps.X
        if(techf.amont.corps.X==0){//fluide froid liquide en entre
 //           if(techf.amont.X==0){//fluide froid liquide en entre
        
            if(false){//z_pinct==1){//pincement minimal
                Tcl=Tfv+DTmin;
                Tcv=Tcl+mCpflv/mCpc*(Tfv-Tfl);
                Tce=Tcv+mCpfv/mCpc*(Tfs-Tfv);
            }
            else if(true){//code_Tfs>0.7){//on suppose ici Tfs connu
                Tcv=Tce-mCpfv/mCpc*(Tfs-Tfv);
    //            Tcl=Tcv-mCpflv/mCpc*(Tfv-Tfl);
                Tcl=Tcv-mCpflv/mCpc;//modRG 08/2009
                Tcs=Tcl-mCpfl/mCpc*(Tfl-Tfe);
            }
            else if(false){//code_Tcs>0.7){//on suppose ici Tcs connu
                Tcl=Tcs+mCpfl/mCpc*(Tfv-Tfe);
                Tcv=Tcl+mCpflv/mCpc*(Tfv-Tfl);
                Tfs=Tfv+mCpc/mCpfv*(Tce-Tcv);
            }
            DTmin=Tcl-Tfv;
            //calcul des changeurs
            epsiv=(Tfs-Tfv)/(Tce-Tfv);
            if((epsiv>0)&&(epsiv<1)){
                Rv=mCpfv/mCpc;
                NUTv=Util.NUT_epsi(epsiv,Rv);
                UAv=mCpfv*NUTv;
            }
            else UAv=0;
            epsilv=(Tcv-Tcl)/(Tcv-Tfv);
            if((epsilv>0)&&(epsilv<1)){
                Rlv=mCpc/mCpflv;
                NUTlv=Util.NUT_epsi(epsilv,Rlv);
                UAlv=mCpc*NUTlv;
            }
            else UAlv=0;
            epsil=(Tfv-Tfe)/(Tce-Tfe);
            if((epsil>0)&&(epsil<1)){
                Rl=mCpfl/mCpc;
                NUTl=Util.NUT_epsi(epsil,Rl);
                UAl=mCpfl*NUTl;
            }
            else UAl=0;
        }
        else{//fluide froid diphasique en entre
            mCpflv=mf*Lf*(1.-techf.amont.X);
            if(false){//z_pinct==1){//pincement minimal
                Tcs=Tfv+DTmin;
                Tcv=Tcs+mCpflv/mCpc*(Tfv-Tfl);
            }
            else if(true){//code_Tfs>0.7){//on suppose ici Tfs connu (T sortie vaporateur)
                Tcv=Tce-mCpfv/mCpc*(Tfs-Tfv);
             //   Tcs=Tcv-mCpflv/mCpc*(Tfv-Tfl);
                Tcs=Tcv-mCpflv/mCpc;//modRG 08/2009
                double x=0;
            }
            else if(false){//code_Tcs>0.7){//on suppose ici Tcs connu
                Tcv=Tcs+mCpflv/mCpc*(Tfv-Tfl);
                Tfs=Tfv+mCpc/mCpfv*(Tce-Tcv);
            }
            Tcl=Tcs;
            DTmin=Tcs-Tfv;
            //calcul des changeurs
            epsiv=(Tfs-Tfv)/(Tce-Tfv);
            Rv=mCpfv/mCpc;
            epsilv=(Tcv-Tcs)/(Tcv-Tfv);
            Rlv=mCpc/mCpflv;
            NUTv=Util.NUT_epsi(epsiv,Rv);
            UAv=mCpfv*NUTv;
            NUTlv=Util.NUT_epsi(epsilv,Rlv);
            UAlv=mCpc*NUTlv;
            UAl=0.;
        }
        
	    if(debug)System.out.println("epsiv "+epsiv+"  epsilv "+epsilv+"  epsil "+epsil);
	    if(debug)System.out.println("Rv "+Rv+"  Rlv "+Rlv+"  Rl "+Rl);
	    if(debug)System.out.println("NUTv "+NUTv+"  NUTlv "+NUTlv+"  NUTl "+NUTl);
	    if(debug)System.out.println("UAv "+UAv+"  UAlv "+UAlv+"  UAl "+UAl);
	    if(debug)System.out.println("Tcv "+Tcv+"  Tcl "+Tcl+"  Tfv "+Tfv);
        UA=UAv+UAlv+UAl;
  //      UA_value.setValue(UA);
        Uv=getUv(techc.amont.X,1);
        Ul=getUl(techc.amont.X,0);
        Ulv=getUlv(techc.amont.X,0);
        setupA(true);
        calcPressureDrops(false);
        U=1000.*UA/A;
        qlv=mCpc*(Tcv-Tcl)/Alv*1000;
        ql=mCpc*(Tcl-Tcs)/Al*1000;
        ql=mCpfl*(Tfl-Tfe)/Al*1000;
  //      qlv=mCpc*(Tce-Tcs)/Alv*1000; densit totale de flux
 	 //   if(debug)
	    	System.out.println("TechnoEvap mCpc "+mCpc+"  qlv "+qlv+"  mCpflv "+mCpflv+"  mCpfv "+mCpfv);
       firstIteration=false;
    }
    
    
    public double getUl(double xc,double xf){
        double u=1;
        if((techc!=null)&&(techf!=null)){
        //    calcNusselt((Tcl+Tcs)/2., (Tfl+Tfe)/2., Pce,Pfe, xc, xf, mCpcl/mc, mCpfl/mf, false,false);
            techc.calcNusselt((Tcl+Tcs)/2., techc.amont.P, xc, mCpcl/mc, false,false);
  //          calcNusselt((Tcl+Tcs)/2., techc.amont.P, xc, mCpcl/mc,false, techc);
            calcNusselt((Tfl+Tfe)/2., techf.amont.P, xf, mCpfl/mf, false,techf);
            u=get_U();
  	      //  if(debug)
        	System.out.println("techc.Pr vap "+techc.getPrCpx()+"  Cpx "+techc.Cpx+"  techc.lambda "+techc.lambda+"  techc.mu "+techc.mu);
    //    if(debug)
        	System.out.println("techf.Pr vap "+techf.getPrCpx()+"  Cpx "+techf.Cpx+"  techf.lambda "+techf.lambda+"  techc.mu "+techc.mu);

        	JLabhlc.setText(resIntTh_fr.getString("hlc")+" = "+Util.aff_d(hc,2)+" Re = "+Util.aff_d(techc.Re,2));
            JLabhlf.setText(resIntTh_fr.getString("hlf")+" = "+Util.aff_d(hf,2)+" Re = "+Util.aff_d(techf.Re,2));
        }
        return u;
    }  
    


	public void calcNusselt(double T, double P, double x, double Cp, 
	    boolean calcDP, TechnoExch te){
	    //T est la temprature moyenne du fluide 
	    //P est la pression du fluide 
	    //x est le titre  prendre en compte pour le calcul des proprits du fluide (lambda et mu)
	    //(x=0 signifie calcul  l'tat liquide, et x=1  l'tat gazeux)
	    //Cp est la capacit thermique massique spcifique
	    //  prendre en compte pour le calcul des proprits des fluides (lambda et mu)
	    //calcDP est true si le calcul de la perte de charge est effectu 
	    //(il n'est pour le moment valable que pour l'changeur en sensible)
	    //diph est true pour le calcul de Ulv dans un changeur 3 steps dclar "cond" ou "evap"
	    // il est false pour le calcul de Ul et Uv, auquel cas il est considr "int_tube" pour le moment
	    // Cette manire de faire pourrait tre amliore. Elle est ncessaire parce qu'un changeur
	    // 3 steps a le mme TechnoHx qu'un changeur normal, ce qui est susceptible d'voluer
		te.initLambdaMu(T, P, x);
	    if(te.mu*te.lambda!=0){
	    	te.calcG();//vitesse massique
	    	te.calcPr(Cp);//nombre de Prandtl Cp en kJ/kg/K
	    	te.calcRe();//nombre de Reynolds
	    	te.Nu=calcNuTube(P);//le relais est pass  la FlowConfig
//	        double dP=fc.calcDP();
	        te.calcH();
	    }
	    else{//message : lambda ou mu du fluide inconnu
		    String message="The conductivity or the viscosity is zero for fluid: "+corps.name;
            message=message+"\nYou should check the corresponding external class";
            JOptionPane.showMessageDialog(new JFrame(),message);
	    }
	}
	  public double calcNuTube(double P){//Implmentation par dfaut
	  		double Tc=(Tcl+Tcs)/2.;
	  		double Tf=(Tfl+Tfe)/2.;
	  		double Tsat=Tfl;
	  		double NUT_f=0;
	  	    double h=1e4;
	  	    double h_f=0;
	  	  double h_c=0;
//			for(int i=1;i<100;i++){
	  	  System.out.println("Tsat "+Tsat);
				for(int i=99;i>0;i--){
				//dcouper l'changeur en 100 parties et 
				//calculer les diffrents quilibres
				//trouver la frontire et faire deux calculs moyens
				double x=i/100.;	
				Tc= Tcl-(Tcl-Tcs)*x;
				Tf= Tfl-(Tfl-Tfe)*x;
				
				//attention,  retravailler
//		        double Twall=(Tc+4*Tf)/5.;//    Tc-(Tc-Tf)/(1+Util.lit_d(techf.tHx.eLambda_value.getText())*Ul);
			    techf.initLambdaMu(Tf,  techf.amont.P, 0);
				double h_db=techf.fc.C1*Math.pow(techf.getRe(),techf.fc.a_Re)*Math.pow(techf.getPr(),techf.fc.b_Pr)/Util.lit_d(techf.Dh_value.getText())*techf.lambda;
			    techc.initLambdaMu(Tc, techc.amont.P, 0);
				h_c=techc.fc.C1*Math.pow(techc.getRe(),techc.fc.a_Re)*Math.pow(techc.getPr(),techc.fc.b_Pr)/Util.lit_d(techc.Dh_value.getText())*techc.lambda;

		        double Twall=(Tc+2*Tf)/3.;//    ds lors qu'il y a dbut d'bulltion, hf > hc
		        double fact=1/(1+h_c/h+h_c*Util.lit_d(techf.tHx.eLambda_value.getText()));
				Twall=Tc-fact*(Tc-Tf);
				//				double h_db=0.023*Math.pow(techf.getRe(),0.8)*Math.pow(techf.getPr(),0.4)/Util.lit_d(techf.Dh_value.getText())*techf.lambda;
		        double twall=Twall-273.15;
		        //Surchauffe en paroi quation de Thom
		        double dTsat=0.5*22.7*Math.exp(-P*0.1/8.7*Math.pow(ql/1e6, 0.5));
		        System.out.println("Twall\t"+twall+"\tx\t"+x+"\tTc\t"+Tc+"\tTf\t"+Tf+"\th_db\t"+h_db+"\th\t"+h);
//		        h=h_db;
				if(Twall>Tsat+dTsat){//Ecoulement liquide avec bullition locale
			        double h_FG=1000/2.16*Math.pow(ql/1000, 0.65)*Math.pow(P,0.23);
	//		        System.out.println("Twall "+twall+"  ql "+ql+"  h_FG "+h_FG+"  h_db "+h_db);
			        double R=(Twall-Tsat-dTsat)/(Twall-Tf);
			        h=h_db*(1-R)+h_FG*R;
			        NUT_f=NUT_f+h*Util.lit_d(techf.Dh_value.getText())/techf.lambda/99.;
			        h_f=h_f+h/99.;
		        }
				else{
					NUT_f=NUT_f+h_db*Util.lit_d(techf.Dh_value.getText())/techf.lambda/99.;
			        h_f=h_f+h_db/99.;
				}
			}
//			double h_g=1/(1/h_c+1/h_f+Util.lit_d(techf.tHx.eLambda_value.getText()));
			NUT_f=NUT_f/(1+NUT_f*Util.lit_d(techf.tHx.eLambda_value.getText()));
//	        System.out.println("Final h_c\t"+h_c+"\th_f\t"+h_f+"\th_g\t"+h_g);
//			
	//		return h_g*Util.lit_d(techf.Dh_value.getText())/techf.lambda;
			
			return NUT_f;
	  }
	
	
	    //Calculs de U vapeur, Corrlation de Colburn
	    public double getUv(double xc,double xf){
	        double u=1;
	        if((techc!=null)&&(techf!=null)){
	            calcNusselt2((Tce+Tcv)/2., techc.amont.P, xc, mCpcv/mc, false, techc);
	            calcNusselt2((Tfs+Tfv)/2., techf.amont.P, xf, mCpfv/mf, false, techf);
/*	            double h_c=techc.Nu/Util.lit_d(techc.Dh_value.getText())*techc.lambda;
	            double h_f=techf.Nu/Util.lit_d(techf.Dh_value.getText())*techf.lambda;
	            
				double h_g=1/(1/h_c+1/h_f+Util.lit_d(techf.tHx.eLambda_value.getText()));
	            
				techf.Nu=h_g*Util.lit_d(techf.Dh_value.getText())/techf.lambda;
	*/            
	            u=get_U();

		      //  if(debug)
		        	System.out.println("techc.Pr vap "+techc.getPrCpx()+"  Cpx "+techc.Cpx+"  techc.lambda "+techc.lambda+"  techc.mu "+techc.mu);
		    //    if(debug)
		        	System.out.println("techf.Pr vap "+techf.getPrCpx()+"  Cpx "+techf.Cpx+"  techf.lambda "+techf.lambda+"  techf.mu "+techf.mu);
	           
	            JLabhvc.setText(resIntTh_fr.getString("hvc")+" = "+Util.aff_d(hc,2)+" Re = "+Util.aff_d(techc.Re,2));
	            JLabhvf.setText(resIntTh_fr.getString("hvf")+" = "+Util.aff_d(hf,2)+" Re = "+Util.aff_d(techf.Re,2));
	        }
	        return u;
	    }
		public void calcNusselt2(double T, double P, double x, double Cp, 
			    boolean calcDP, TechnoExch te){
				te.initLambdaMu(T, P, x);
			    if(te.mu*te.lambda!=0){
			    	te.calcG();//vitesse massique
			    	te.calcPr(Cp);//nombre de Prandtl Cp en kJ/kg/K
			    	te.calcRe();//nombre de Reynolds
			    	te.Nu=calcNuTube2(T, P, x, te);//le relais est pass  la FlowConfig
//			        double dP=fc.calcDP();
			    	te.calcH();
			    }
			    else{//message : lambda ou mu du fluide inconnu
				    String message="The conductivity or the viscosity is zero for fluid: "+corps.name;
		            message=message+"\nYou should check the corresponding external class";
		            JOptionPane.showMessageDialog(new JFrame(),message);
			    }
			}



		  public double calcNuTube2(double T, double P, double x, TechnoExch te){//Implmentation par dfaut
		        te.initLambdaMu(T, P, x);
				double NUT=0.023*Math.pow(te.getRe(),0.8)*Math.pow(te.getPr(),1./3.);
	        	System.out.println("calcNuTube2 te.Pr vap "+te.getPr()+"  Re "+te.getRe()+"  NUT "+NUT);
			
				return NUT;
		  }
		
    
    
}