/*
Copyright Renaud GICQUEL 2005-2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/package extThopt;

import java.util.StringTokenizer;

import rg.thopt.*;


public class TechnoCondensor extends TechnoHx
{
     
	public TechnoCondensor()
	{
        super();
    }
	public TechnoCondensor(Projet proj, String hXname, PointThopt amontHot, PointThopt avalHot, PointThopt amontCold, PointThopt avalCold)
	{
	    super(proj, hXname, amontHot, avalHot, amontCold, avalCold);
	    corps=new CorpsThopt(proj, amontHot.nomCorps, amontHot.lecorps);
    }
	public TechnoCondensor(Projet proj, String hXname)
	{
	    super(proj, hXname);
	    corps=new CorpsThopt(proj, amontHot.nomCorps, amontHot.lecorps);
    }
	
  	public String getClassDescription(){
	    return "condensor class\n\nauthor : R. Gicquel  march 2008\n\nRef : archive ";
	}
    public String getType(){
        return "condensor";
    }
    public String getCompType(){
        return "condensor";
    }
	
    public String getClassName(){
        return "TechnoCondensor";
    }
	
    public void makeDesign(){//chaud diphasique, froid en sensible (condenseur)
        resetHX();
        Pce=techc.amont.P;
        double Pcs=techc.aval.P;//modRG 08/2009
        double Pcond=(Pce+Pcs)/2.;
 //       Tcv=corps.lecorps.getSatTemperature(Pce,0);
        Tcl=corps.lecorps.getSatTemperature(Pcond,0);
        Tcv=corps.lecorps.getSatTemperature(Pcond,1);
  //      System.out.println("Tcl "+Tcl+"  Tcv "+Tcv+" corps.lecorps "+corps.name);
//	    corps.lecorps.CalcPropCorps(Tcv-0.1, Pce, 0);
	    corps.lecorps.CalcPropCorps(Tcl-0.1, Pcond, 0);//modRG 08/2009
//	    corps.lecorps.CalcPropCorps(Tcv-0.1, Pcond, 1);//modRG 11/2009
	    corps.getSubstProperties();
        double Hl=corps.H;
//	    corps.lecorps.CalcPropCorps(Tcv+0.1, Pce, 1);
	    corps.lecorps.CalcPropCorps(Tcv+0.1, Pcond, 1);//modRG 08/2009
	    corps.getSubstProperties();
        double Hv=corps.H;
    //    Tcl=Tcv-0.1;
        Lc=Hv-Hl;
        mCpclv=mc*Lc; 
        
        //on estime les mCp liquide et vapeur indpendamment des tats des points amont et aval existants
//	    corps.lecorps.CalcPropCorps(Tcv+10, Pce, 1);
	    corps.lecorps.CalcPropCorps(techc.amont.T, Pce, 1);//modRG 08/2009
	    corps.getSubstProperties();
	    Hv=corps.H;
	    corps.lecorps.CalcPropCorps(techc.amont.T+2, Pce, 1);//modRG 08/2009
	    corps.getSubstProperties();
//        mCpcv=mc*(corps.H-Hv)/10.;
        mCpcv=mc*(corps.H-Hv)/2.;//modRG 08/2009
//	    corps.lecorps.CalcPropCorps(Tcv-5, Pce, 1);
	    corps.lecorps.CalcPropCorps(techc.aval.T, Pcs, 0);//modRG 08/2009
	    corps.getSubstProperties();
//	    Hl=corps.H;
//	    corps.lecorps.CalcPropCorps(techc.aval.T, Pcs, 1);//modRG 11/2009
	    corps.getSubstProperties();
	    Hl=corps.H;
	    corps.lecorps.CalcPropCorps(techc.aval.T-2, Pcs, 0);//modRG 08/2009
//	    corps.lecorps.CalcPropCorps(techc.aval.T-2, Pcs, 1);//modRG 11/2009
	    corps.getSubstProperties();
//        mCpcl=mc*(Hl-corps.H)/5.;
        mCpcl=mc*(Hl-corps.H)/2.;//modRG 08/2009

        mCpflv=mCpf;
        mCpfv=mCpf;
        mCpfl=mCpf;
        
        if(techc.amont.X==1){//fluide chaud gazeux en entre
            if(false){//z_pinct==1){//pincement minimal
                Tfv=Tcv-DTmin;
                Tfl=Tfv-mCpclv/mCpf*(Tcv-Tcl);
                Tfs=Tfv+mCpcv/mCpf*(Tce-Tcv);
            }
            else if(false){//code_Tfs>0.7){//on suppose ici Tfs connu
                Tfv=Tfs-mCpcv/mCpf*(Tce-Tcv);
                Tfl=Tfv-mCpclv/mCpf*(Tcv-Tcl);
                Tcs=Tcv-mCpf/mCpcl*(Tfl-Tfe);
            }
            else if(true){//code_Tcs>0.7){//on suppose ici Tcs connu (sous-refroidissement impos)
                Tfl=Tfe+mCpcl/mCpf*(Tcl-Tcs);
       //         Tfv=Tfl+mCpclv/mCpf*(Tcv-Tcl);
                Tfv=Tfl+mCpclv/mCpf;//modRG 08/2009
                Tfs=Tfv+mCpcv/mCpf*(Tce-Tcv);
            }
            DTmin=Tcv-Tfv;
            //calcul des changeurs
            epsiv=(Tce-Tcv)/(Tce-Tfv);
            Rv=mCpcv/mCpf;
            epsilv=(Tfv-Tfl)/(Tcl-Tfl);
            Rlv=mCpf/mCpclv;
            epsil=(Tcl-Tcs)/(Tcl-Tfe);
            Rl=mCpcl/mCpf;
            NUTv=Util.NUT_epsi(epsiv,Rv);
            UAv=mCpcv*NUTv;
            NUTlv=Util.NUT_epsi(epsilv,Rlv);
            UAlv=mCpf*NUTlv;
            NUTl=Util.NUT_epsi(epsil,Rl);
            UAl=mCpcl*NUTl;
        }
        else{//fluide diphasique en entre
            mCpclv=mc*Lc*techc.amont.X;        
            if(false){//z_pinct==1){//pincement minimal
   //             Tfv=Tcv-DTmin;
   //             Tfl=Tfv-mCpclv/mCpf*(Tcv-Tcl);
   //             Tfs=Tfv+mCpcv/mCpf*(Tce-Tcv);
            }
            else if(false){//code_Tfs>0.7){//on suppose ici Tfs connu
   //             Tfv=Tfs-mCpcv/mCpf*(Tce-Tcv);
   //             Tfl=Tfv-mCpclv/mCpf*(Tcv-Tcl);
   //             Tcs=Tcv-mCpf/mCpcl*(Tfl-Tfe);
            }
            else if(true){//code_Tcs>0.7){//on suppose ici Tcs connu (sous-refroidissement impos)
                Tfl=Tfe+mCpcl/mCpf*(Tcv-Tcs);
          //         Tfs=Tfl+mCpclv/mCpf*(Tcv-Tcl);
                Tfs=Tfl+mCpclv/mCpf;//modRG 08/2009
             Tfv=Tfs;
            }
            DTmin=Tcv-Tfl;
            //calcul des changeurs
            epsilv=(Tfs-Tfl)/(Tcl-Tfl);
            Rlv=mCpf/mCpclv;
            epsil=(Tcl-Tcs)/(Tcl-Tfe);
            Rl=mCpcl/mCpf;
            UAv=0;
            NUTlv=Util.NUT_epsi(epsilv,Rlv);
            UAlv=mCpf*NUTlv;
            NUTl=Util.NUT_epsi(epsil,Rl);
            UAl=mCpcl*NUTl;
        }
        UA=UAv+UAlv+UAl;
	    if(debug)System.out.println("epsiv "+epsiv+"  epsilv "+epsilv+"  epsil "+epsil);
	    if(debug)System.out.println("Rv "+Rv+"  Rlv "+Rlv+"  Rl "+Rl);
	    if(debug)System.out.println("mCpf "+mCpf+"  mCpclv "+mCpclv+"  mCpcv "+mCpcv+"  mCpcl  "+mCpcl);
	    if(debug)System.out.println("NUTv "+NUTv+"  NUTlv "+NUTlv+"  NUTl "+NUTl);
	    if(debug)System.out.println("UAv "+UAv+"  UAlv "+UAlv+"  UAl "+UAl);
	    double tcv=Tcv-273.15;
	    double tfv=Tfv-273.15;
	    double tfl=Tfl-273.15;
	    double tfs=Tfs-273.15;
	    if(debug)System.out.println("tcv "+tcv+"  tfs "+tfs+"  tfv "+tfv+"  tfl "+tfl);
        if(UAv!=0)Uv=getUv(1,techf.amont.X);
        else Uv=1;
        Ul=getUl(0,techf.amont.X);
        Ulv=getUlv(0,techf.amont.X);
        setupA(true);
        calcPressureDrops(false);
        U=1000.*UA/A;
        qlv=mCpf*(Tfv-Tfl)/Alv*1000;
        firstIteration=false;

   }
	public void readSpecificParams(String ligne_data){
		StringTokenizer st= new StringTokenizer(ligne_data,":");
	    String ligne = st.nextToken();
        String value=Util.extr_value(ligne, "ADesign_value");
//		if(!(value==null))ADesign_value.setText(value);
		value=Util.extr_value(ligne, "eLambda");
//		if(!(value==null))eLambda_value.setText(value);
		value=Util.extr_value(ligne, "qlv");
		if(!(value==null))qlv=Util.lit_d(value);
		if(debug)System.out.println("pass dans readSpecificParams "+value);
	
	}

}