/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;


public class TechnoEvaporator extends TechnoHx
{
	public TechnoEvaporator()
	{
        super();
    }
	public TechnoEvaporator(Projet proj, String hXname, PointThopt amontHot, PointThopt avalHot, PointThopt amontCold, PointThopt avalCold)
	{
	    super(proj, hXname, amontHot, avalHot, amontCold, avalCold);
	    corps=new CorpsThopt(proj, amontCold.nomCorps, amontCold.lecorps);
    //	debug=true;

    }
	public TechnoEvaporator(Projet proj, String hXname)
	{
	    super(proj, hXname);
	    corps=new CorpsThopt(proj, techf.amont.nomCorps, techf.amont.lecorps);
   // 	debug=true;

    }
  	public String getClassDescription(){
	    return "evaporator class\n\nauthor : R. Gicquel  march 2008\n\nRef : archive ";
	}
	
    public String getType(){
        return "evaporator";
    }
    public String getCompType(){
        return "evaporator";
    }
    public String getClassName(){
        return "TechnoEvaporator";
    }
	
    public void makeDesign(){//chaud en sensible, froid diphasique (vaporateur)
        resetHX();
        Pfe=techf.amont.P;
        double Pfs=techf.aval.P;
        Tfl=corps.lecorps.getSatTemperature(Pfe,0);
        Tfv=corps.lecorps.getSatTemperature(Pfe,1);
	    corps.lecorps.CalcPropCorps(Tfl-0.1, Pfe, 0);
//	    System.out.println("corps "+corps.name+"  T "+Util.aff_d(Tfl-273.15)+"  Pfe "+Pfe);
	    corps.getSubstProperties();
	    corps.lecorps.CalcPropCorps(Tfl-0.1, Pfe, 0);
	    corps.getSubstProperties();
        double Hl=corps.H;
	    corps.lecorps.CalcPropCorps(Tfv+0.1, Pfe, 1);
	    corps.getSubstProperties();
        double Hv=corps.H;
 //       Tfl=Tfv-0.1;
        Lf=Hv-Hl;
        mCpflv=mf*Lf;   
 /*       
        //on estime les mCp liquide et vapeur indpendamment des tats des points amont et aval existants
	    corps.lecorps.CalcPropCorps(Tfv+10, Pfe, 1);
	    corps.getSubstProperties();
        mCpfv=mf*(corps.H-Hv)/10.;
	    corps.lecorps.CalcPropCorps(Tfs+2, Pfs, 1);//modRG 08/2009
	    corps.getSubstProperties();
        mCpfv=mf*(corps.H-techf.aval.H)/2.;*/
        
        //calcul de mCpfv, moyenne entre l'entre et la sortie  
	    corps.lecorps.CalcPropCorps(Tfs, Pfs, 1);
	    corps.getSubstProperties();
	    Hv=corps.H; 
	    corps.lecorps.CalcPropCorps(Tfv+0.01, Pfs, 1);//modRG 12/2021
	    corps.getSubstProperties();
	    mCpfv=mf*(corps.H-Hv)/(Tfv-Tfs);
        
	    mCpfl=mf*(Hl-techf.amont.H)/(Tfl-0.1-techf.amont.T);

        mCpclv=mCpc;        
        mCpcv=mCpc;
        mCpcl=mCpc;        
        //te.amont.X=te.amont.corps.X
        if(techf.amont.X==0){//fluide froid liquide en entre
 //           if(techf.amont.X==0){//fluide froid liquide en entre
        	if(debug)System.out.println("fluide froid liquide en entre techf.amont.X "+techf.amont.X);
       
            Tcv=Tce-mCpfv/mCpc*(Tfs-Tfv);
            Tcl=Tcv-mCpflv/mCpc;//modRG 08/2009
            Tcs=Tcl-mCpfl/mCpc*(Tfl-Tfe);
            DTmin=Tcl-Tfv;
            //calcul des changeurs
            
            //surchauffeur
            Rv=mCpfv/mCpc;
            if(Rv<=1){
           	 epsiv=(Tfs-Tfv)/(Tce-Tfv);
		        if((epsiv>0)&&(epsiv<1)){
		            NUTv=Util.NUT_epsi(epsiv,Rv);
		            UAv=mCpfv*NUTv;            	
		         }
		        else UAv=0;
          }
           else{
           	epsiv=(Tce-Tcv)/(Tce-Tfv);
           	Rv=mCpc/mCpfv;
		        if((epsiv>0)&&(epsiv<1)){
		            NUTv=Util.NUT_epsi(epsiv,Rv);
		            UAv=mCpc*NUTv;            	
		         }
		        else UAv=0;
          }
           
            
           //vaporiseur 
             epsilv=(Tcv-Tcl)/(Tcv-Tfv);
            if((epsilv>0)&&(epsilv<1)){
                Rlv=mCpc/mCpflv;
                NUTlv=Util.NUT_epsi(epsilv,Rlv);
                UAlv=mCpc*NUTlv;
            }
            else UAlv=0;
            
            //conomiseur
            
            Rl=mCpfl/mCpc;
            if(Rl<=1){
			 epsil=(Tfl-Tfe)/(Tcl-Tfe);
			if((epsil>0)&&(epsil<1)){
				Rl=mCpfl/mCpc;
				NUTl=Util.NUT_epsi(epsil,Rl);
				UAl=mCpfl*NUTl;
			}
			else UAl=0;
          }
           else{
			 epsil=(Tcl-Tcs)/(Tcl-Tfe);
          	Rl=mCpc/mCpfl;
			if((epsil>0)&&(epsil<1)){
				NUTl=Util.NUT_epsi(epsil,Rl);
				UAl=mCpfl*NUTl;
			}
			else UAl=0;
          }
        }
        else{//fluide froid diphasique en entre
        	if(debug)System.out.println("fluide froid diphasique en entre ");

            mCpflv=mf*Lf*(1.-techf.amont.X);
 /*           Tcv=Tce-mCpfv/mCpc*(Tfs-Tfv);
             //   Tcs=Tcv-mCpflv/mCpc*(Tfv-Tfl);
            Tcs=Tcv-mCpflv/mCpc;//modRG 08/2009
     */       
            Tcv=Tce-mCpfv/mCpc*(Tfs-Tfv);
            Tcl=Tcv-mCpflv/mCpc;//modRG 08/2009
            Tcs=Tcl;
            DTmin=Tcs-Tfv;
            //calcul des changeurs
/*            epsiv=(Tfs-Tfv)/(Tce-Tfv);
            Rv=mCpfv/mCpc;
            epsilv=(Tcv-Tcl)/(Tcv-Tfl);//modRG 2021
            Rlv=mCpc/mCpflv;
            NUTv=Util.NUT_epsi(epsiv,Rv);
            UAv=mCpfv*NUTv;
            NUTlv=Util.NUT_epsi(epsilv,Rlv);
            UAlv=mCpc*NUTlv;
            UAl=0.;
            epsiv=(Tfs-Tfv)/(Tce-Tfv);
            if((epsiv>0)&&(epsiv<1)){
                Rv=mCpfv/mCpc;
                NUTv=Util.NUT_epsi(epsiv,Rv);
                UAv=mCpfv*NUTv;
            }
            else UAv=0;
            */
           
            //surchauffeur
            Rv=mCpfv/mCpc;
            if(Rv<=1){
           	 epsiv=(Tfs-Tfv)/(Tce-Tfv);
		        if((epsiv>0)&&(epsiv<1)){
		            NUTv=Util.NUT_epsi(epsiv,Rv);
		            UAv=mCpfv*NUTv;            	
		         }
		        else UAv=0;
          }
           else{
           	epsiv=(Tce-Tcv)/(Tce-Tfv);
           	Rv=mCpc/mCpfv;
		        if((epsiv>0)&&(epsiv<1)){
		            NUTv=Util.NUT_epsi(epsiv,Rv);
		            UAv=mCpc*NUTv;            	
		         }
		        else UAv=0;
          }
           
            
           //vaporiseur 
             epsilv=(Tcv-Tcl)/(Tcv-Tfl);
            if((epsilv>0)&&(epsilv<1)){
                Rlv=mCpc/mCpflv;
                NUTlv=Util.NUT_epsi(epsilv,Rlv);
                UAlv=mCpc*NUTlv;
            }
            else UAlv=0;       
            
        }
        if(debug)System.out.println("TechnoEvaporator ");
        if(debug)System.out.println("Tfl "+Tfl+"  Tfv "+Tfv+" corps.lecorps "+corps.name+" mCpflv "+mCpflv);
        if(debug)System.out.println("techf.amont.X "+techf.amont.X+" Hl "+Hl+"  Hv "+Hv+" Tfl "+Tfl+" Tfv "+Tfv+" Pfe "+Pfe);
   
	    if(debug)System.out.println("epsiv "+epsiv+"  epsilv "+epsilv+"  epsil "+epsil);
	    if(debug)System.out.println("Rv "+Rv+"  Rlv "+Rlv+"  Rl "+Rl);
	    if(debug)System.out.println("NUTv "+NUTv+"  NUTlv "+NUTlv+"  NUTl "+NUTl);
	    if(debug)System.out.println("UAv "+UAv+"  UAlv "+UAlv+"  UAl "+UAl);
	    if(debug)System.out.println("Tcv "+Tcv+"  Tcl "+Tcl+"  Tfv "+Tfv);
        UA=UAv+UAlv+UAl;
  //      UA_value.setValue(UA);
        Uv=getUv(techc.amont.X,1);
        Ul=getUl(techc.amont.X,0);
        Ulv=getUlv(techc.amont.X,0);
        setupA(true);
        calcPressureDrops(false);
        U=1000.*UA/A;
  //      qlv=mCpc*(Tcv-Tcl)/Alv*1000;
        qlv=mCpc*(Tcv-Tcl)/Alv;//*1000; 
  //      qlv=mCpc*(Tce-Tcs)/Alv*1000; densit totale de flux
 	 //   if(debug)
        if(debug)System.out.println("TechnoEvap mCpc "+mCpc+"  qlv "+qlv+"  mCpflv "+mCpflv+"  mCpfv "+mCpfv);
       firstIteration=false;
    }
    
}