/*
Copyright Renaud GICQUEL 2005-2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;

/**
 * Classe de dimensionnement technologique d'une turbine
 * Technological design class for turbines
 */

public class TechnoNozzle extends TechnoSimpleTurb
{
    String nozzleName;
	boolean CHOKED_NOZZLE=true;

	public TechnoNozzle(){
	}
	public TechnoNozzle(Projet proj, String nozzleName, PointThopt amont, PointThopt aval){
		super(proj, nozzleName, amont, aval);
	    this.nozzleName=componentName;
	    cleanScreen();
	}
	public TechnoNozzle(Projet proj, String nozzleName){
		super(proj, nozzleName);
	    this.nozzleName=componentName;
	    cleanScreen();
	}

	void cleanScreen(){//sans doute non ncessaire
        JPanel1.remove(JLabel17);
        JPanel1.remove(beta_value);
        JPanel1.remove(JLabel16);
        JPanel1.remove(D_value);
        JPanel1.remove(JCheckPVR);
        JPanel1.remove(JLabel8);
        JPanel1.remove(alphaBaumann_value);
        JPanel1.remove(JLabel1);
        JPanel1.remove(outletArea_value);
        JPanel1.remove(N_value);
        JPanel1.remove(JLabel2);
        JPanel1.remove(display_value);
        JPanel1.remove(displayLabel);
	}
	   public String getType(){
	        return "TechnoNozzle";
	    }
	   public String getCompType(){
	        return "TechnoNozzle";
	    }
	
    public String getClassName(){
        return "TechnoNozzle";
    }
    public String getClassCode(){
        return "Nozzle";
    }
    
    void setupPanel(){
        super.setupPanel();
        JCheckChoked.setLabel("choked nozzle");
    }
    
    
    private double getZ(double P){
        double z=1;
        if(CHOKED_NOZZLE){//pas d'influence de l'aval
            z=P*P/amont.T;
//            z=P*P/aval.T;//variante si on veut imposer le dbit choqu en sortie
        }
        else{
            z=(P*P-aval.P*aval.P)/amont.T;
        }
        return z;
    }
    
    //inversion en P de la caractristique turbine connaissant le dbit
    public double getTurbineInletPressure(double flow){
        double P=0.;
        if(CHOKED_NOZZLE){//pas d'influence de l'aval
            P=flow*Math.pow(amont.T, 0.5)/Kh;
//            P=flow*Math.pow(aval.T, 0.5)/Kh;//variante si on veut imposer le dbit choqu en sortie
        }
        else{
            double y=flow*flow*amont.T/Kh/Kh+aval.P*aval.P;
            P=Math.pow(y, 0.5);
        }
	    return P;
    }
    	
}
 