/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import rg.corps.*; 
import rg.thopt.*;
import javax.swing.*;

/**
* This class enables you to add external nodes to Thermoptim.
*<p>
* To add one component, subclass ExtMixer or ExtDivider by providing the appropriate methods
* in particular, getType() must return the component type as it will appear in
* the process list.
*<p>This class should not be modified
 * 
 * @author Renaud GICQUEL
*/
public class ExtNode extends ExtProcess 
{
	String mainProcess;
	String[]nomBranche;
	int nBranches;
	boolean isBuilt=true;
    Vector[]vTransfo,vPoints;

    public ExtNode (){
        super();
    }
    /**
	* Charge la structure du noeud
    *<p>
	* Loads the node structure
    * <p>
    * not to be overridden by subclasses
	*/
    public void getNodeStructure(String nom){
	    String[] args=new String[2];
	    args[0]="node";//type of the element (see method getProperties(String[] args))
	    args[1]=nom;//name of the process (see method getProperties(String[] args))
	    Vector vProp=proj.getProperties(args);
	    mainProcess=(String)vProp.elementAt(0);
	    Integer nb=(Integer)vProp.elementAt(4);
	    nBranches=nb.intValue();
        System.out.println(" mainProcess "+mainProcess+" number of branches : "+nBranches);
	    nomBranche=new String[nBranches];
        for(int j=0;j<nBranches;j++){
            nomBranche[j]=(String)vProp.elementAt(5+j);
            System.out.println(" branch "+j+" : "+nomBranche[j]);
	    }
    }
  
    /**
	* Mise  jour rcurrente de transfos amont ou aval 
	*<p>
	* Updates recurrently inlet or outlet processes
    * <p>
    * not to be overridden by subclasses
	**/
    public void updateStraightlyConnectedProcess(String startProcess, String name, boolean downstream, 
        boolean inletPoint, boolean outletPoint, boolean updateT, double T,  
        boolean updateP, double P, boolean updateX, double x){
	    String inletPointName="",outletPointName="",nextProcess="";
	    String[] args=new String[2];
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=name;//name of the process (see method getProperties(String[] args))
	    Vector vProp=proj.getProperties(args);
	    inletPointName=(String)vProp.elementAt(1);
	    outletPointName=(String)vProp.elementAt(2);
	    if(downstream)nextProcess=(String)vProp.elementAt(10);
	    else nextProcess=(String)vProp.elementAt(9);
	    if(inletPoint){
         Vector vPoint=new Vector();
         vPoint.addElement(inletPointName);
         vPoint.addElement(Util.aff_b(updateT));
         vPoint.addElement(Util.aff_d(T));
         vPoint.addElement(Util.aff_b(updateP));
         vPoint.addElement(Util.aff_d(P));
         vPoint.addElement(Util.aff_b(updateX));
         vPoint.addElement(Util.aff_d(x));
         proj.updatePoint(vPoint);
	    }
	    if(outletPoint){
         Vector vPoint=new Vector();
         vPoint.addElement(outletPointName);
         vPoint.addElement(Util.aff_b(updateT));
         vPoint.addElement(Util.aff_d(T));
         vPoint.addElement(Util.aff_b(updateP));
         vPoint.addElement(Util.aff_d(P));
         vPoint.addElement(Util.aff_b(updateX));
         vPoint.addElement(Util.aff_d(x));
         proj.updatePoint(vPoint);
	    }
	    if((!nextProcess.equals("null"))&&(!nextProcess.equals(startProcess))){
	        updateStraightlyConnectedProcess(startProcess, nextProcess, downstream, 
                inletPoint, outletPoint, updateT, T, updateP, P, updateX, x);
	    }
    }
  
    /**
	* Met  jour le noeud
	*<p>
	* Updates the node
    * <p>
    * not to be overridden by subclasses
	**/
	protected Vector getUpdateVector(Vector[]vTransfo,Vector[]vPoints, double TGlobal, double hGlobal){
	    return getUpdateVector(vTransfo, vPoints, TGlobal, hGlobal, true);
	}
	protected Vector getUpdateVector(Vector[]vTransfo,Vector[]vPoints, double TGlobal, double hGlobal, boolean displayValues){
	
        Vector vTC=new Vector();
        for(int j=0;j<vTransfo.length;j++){
            vTC.addElement(vTransfo[j]);
        }
        for(int j=0;j<vPoints.length;j++){
            vTC.addElement(vPoints[j]);
        }
        Vector vGlobal=new Vector();
        vGlobal.addElement(new Double(TGlobal));
        vGlobal.addElement(new Double(hGlobal));
        vGlobal.addElement(Util.aff_b(displayValues));
        vTC.addElement(vGlobal);
        return vTC;
	}
  
  
  
    /**
	* Met  jour les Vector de transfo et de point d'une branche ou de la veine principale
	*<p>
	* Updates the process and point Vector for a branch or the main vein
    * <p>
    * not to be overridden by subclasses
	**/
      void setupVector(String process, String point, int i, double m, double T, double P, double X){
        vTransfo[i]=new Vector();
        vPoints[i]=new Vector();
        vTransfo[i].addElement(process);
        vTransfo[i].addElement(new Double(m));
 
        vPoints[i].addElement(point);
        vPoints[i].addElement(new Double(T));
        vPoints[i].addElement(new Double(P));
        vPoints[i].addElement(new Double(X));
    }
	/**
	* Construit le Vector de mise  jour du thermocoupleur du type donn
    *<p>
	* Builds the Vector for updating the thermocoupler of the type given
    * <p>
    * not to be overridden by subclasses
    * @param type String (thermocoupler ID)
    * @param Tin double (inlet temperature)
    * @param Tout double (outlet temperature)
    * @param Q double (heat load)
    * @param flow double (mass flow rate)
	*/
    protected Vector getThermoCouplerVector(String type, double Tin, double Tout, double Q, double flow){
        Vector vTC=new Vector();
        vTC.addElement(type);
        Double d=new Double(Tin);
        vTC.addElement(d);
        d=new Double(Tout);
        vTC.addElement(d);
        d=new Double(Q);
        vTC.addElement(d);
        d=new Double(flow);
        vTC.addElement(d);
        return vTC;
    }
  
	/**
	* Construit le Vector de mise  jour du thermocoupleur du type donn
    *<p>
	* Builds the Vector for updating the thermocoupler of the type given
    * <p>
    * not to be overridden by subclasses
    * @param type String (thermocoupler ID)
    * @param Tin double (inlet temperature)
    * @param Tout double (outlet temperature)
    * @param Q double (heat load)
    * @param flow double (mass flow rate)
    * @param isPinchFluid boolean (true if to be taken into account in optimization method)
    * @param DTmin double (pinch value)
	*/
    protected Vector getThermoCouplerVector(String type, double Tin, double Tout, double Q, double flow, boolean isPinchFluid, double DTmin){
        Vector vTC=new Vector();
        vTC.addElement(type);
        Double d=new Double(Tin);
        vTC.addElement(d);
        d=new Double(Tout);
        vTC.addElement(d);
        d=new Double(Q);
        vTC.addElement(d);
        d=new Double(flow);
        vTC.addElement(d);
        Boolean b=new Boolean(isPinchFluid);
        vTC.addElement(b);
        d=new Double(DTmin);
        vTC.addElement(d);
        return vTC;
    }
/*   public String[] getExergyType(){//modRG exerg
        String[] type=new String[9];
        type[0]="reductor";//extensor ou reductor/extensor
        type[1]="false";//affiche JCheckExtSource
        type[2]="External source";//label JCheckExtSource
        type[3]="false";//affiche JCheckIntExchange
        type[4]="Internal exchange";//label JCheckIntExchange
        type[5]="false";//affiche JCheckValuableExergy
        type[6]="Valuable exergy";//label JCheckValuableExergy
        type[7]="false";//affiche champ d'entre de valeur
        type[8]="Source T (C)";//label sourceT_value
        return type;
    }*/
    
}